;Stockcar Scramble
;stockcar model comes from the Darkmatter CD

;Controls - Arrow Keys
;Number Keys 1-9 give different camera views
;Press R to reset

Include "include.bb"

Graphics3D 640,480,16

Global numcars=12,racetracks=3
Global mir_offset#,opsize=3
Global ghostween=10,dotrees=1
Global holtime=MilliSecs()
Global posx#,posy#,posz#
Global waiting=MilliSecs()
Global t3=LoadSound("stuff/sfx/t3.wav")
Global t2=LoadSound("stuff/sfx/t2.wav")
Global t1=LoadSound("stuff/sfx/t1.wav")


Dim optname$(10)
optname$(1)="DIFFICULTY"
optname$(2)="RIVAL NAMES"
optname$(3)="MUSIC"

Dim optsize(10),ochoice(10)
Data 4,2,2
For tt=1 To opsize
Read optsize(tt)
ochoice(tt)=1
Next

Dim qualpos(12)
For ff=1 To 12
qualpos(ff)=13-ff
Next


Dim opton$(10,10)
For tt=1 To 10
opton$(tt,1)="ON"
opton$(tt,2)="OFF"
Next
opton$(1,1)="EASY"
opton$(1,2)="NORMAL"
opton$(1,3)="HARD"
opton$(1,4)="ULTRA"


Const trackwid=15,tunsegs=8

Global reverse=0,mirror=0,cmirror=0,nchoice=1,gateverse=0
Global lestur#,initlook=0

Global framtot=0,fram3=0

Global charset=LoadAnimImage("charset.png",40,40,0,30)
Global charset2=LoadAnimImage("charset.png",40,40,0,30)
ScaleImage charset2,0.5,0.5

Dim m_offset#(racetracks)
;-1000+(terrsize-1)*scalefactor
Data -235,-111,270
For jb=1 To racetracks
Read m_offset#(jb)
Next

Dim tery(50,50)
Dim totvert(racetracks)

For ig=1 To racetracks

If Not(FileType(terrmap$(ig,1)))

uu=LoadImage(terrmap$(ig))

ScaleImage uu,-1,1

ok=SaveImage(uu,terrmap$(ig,1))

EndIf

Next


Dim normal$(4)
normal$(1)="NORMAL"
normal$(2)="MIRRORED"
normal$(3)="REVERSED"
normal$(4)="COMBINED"


Dim tracklaps(racetracks)
tracklaps(1)=10
tracklaps(2)=4
tracklaps(3)=3

Dim t_mirror(racetracks)

Dim enemybase#(racetracks,2)
Data 0.005,0.04
Data 0.005,0.04
Data 0.005,0.04

For km=1 To racetracks
For kn=1 To 2
Read enemybase#(km,kn)
Next
Next

Dim zoom#(racetracks)
Data 1,1,0.8
For ki=1 To 3
Read zoom#(ki)
Next

Global tunnel,tunsurf

Dim tuntex(2)

tuntex(1)=LoadTexture("stuff/textures/mud1.bmp")
tuntex(2)=LoadTexture("stuff/textures/urb008.bmp")

Dim tunneldat(20,2000)
Dim tunhere(2000)
tunneldat(2,50)=1
tunneldat(2,150)=1
tunneldat(2,225)=2
tunneldat(2,275)=2

Const CARSIZE#=0.8
Const GRAVITY#=-.015
Const convert=180 ;(speed in units <> speed in kph)

Const BODY=1,WHEEL=2,SCENE=3,TARMAC=4,STRUCT=5
Const NOCOL=6,SIDE=7,BODYROAD=8,WHEELROAD=9,BSCENE=10
Const BOXSTRUCT=11,TUNSTRUCT=12

Const tlev=1000,tdet=1000

Global SFX_car       = LoadSound("stuff/sfx/motor_auto.wav")
LoopSound SFX_car

Dim car_engine(40),envol#(40)

For ii=1 To numcars
car_engine(ii) = PlaySound(SFX_car)
ChannelVolume car_engine(ii),0
Next

Dim vx#(3),vy#(3),vz#(3),vo#(3)

Global seedebug=0,overstart=0,obs=0

Global wturn#=0,wrot#=0,playercar=1,started=0
Global change,onscene,targ=1,oldhat=0,oldjoy=0
Global allcpu=0,racestart=0,accel#=0.5,level=1
Global carx#,cary#,carz#,carpi#,carya#,carro#
Global laptimer,rem_laptimer
Global bestlap=0,record=0
Global co_left,co_right,co_for,co_rev
Global newview=2,roadcam=0,yonscene=0
Global yourplace,verx#,very#,verz#
Global sigrol#,sigyaw#,toggle=1
Global my_timer=CreateTimer(75)
Global snapview=0
Global wx#,wy#,wz#,xn#,yn#
Global colang#,carvel#,endrace=0
Global respot,inair=0,bturn#=0,rotat=1
Global countdown,rem_countdown,countnum=3
Global game_type ;type of game being played (arcade, time trial, etc)
Global best_time$
Global skycamx#=0,skycamy#=0,impacts=0,slowdown=0
Global watch=0,hitstruct=0,nextpiece=0
Global mapangle#=0,youang#=0,road_angle#=0
Global kks=0,actnow=0,uuu#=0
Global newcar,yourcar,ghostcar,framenum=0,showghost=0
Global lagg=0,showlagg=0,gwturn=0,scenetween=0

Global rstref=0,bbb=0,ggg=0,rrr=0,offset#=603,twoset#=603
Global mapx#,mapy#,nextcheck=1
Global road_angle2#,yourname$
Global frameslost=0,road_angle1#
Global roadf1#,roadf2#,roadf3#,ccyaw#,peril#
Global dvx#,dvz#

Global controls=2 ;keyboard or joypad
Global namescreen=1
Global newname$=""
Global outlook=0,dvy#=0
Global sumofspeed=0,countspeed=0
Global menuscreen=1,alpha#=0,gamechoice
Global rtimed,racetimer,toglim
Global roadline#,whole=0,tut=0
Global linelength#,linepos#
Global oex#,oey#,oez#,offline#
Global totverts,vang#,lastlap=0
Global dturn2#




Dim race_line#(1000)

Dim opponent$(18)
opponent$(1)="CLARKSON"
opponent$(2)="BLYTHE"
opponent$(3)="PEPPER"
opponent$(4)="CARR"
opponent$(5)="SHEEDY"
opponent$(6)="LEMONT"
opponent$(7)="HOLT"
opponent$(8)="TEARLE"
opponent$(9)="WEAVER"
opponent$(10)="GREGORY"
opponent$(11)="RILLA"
opponent$(12)="NEAL"
opponent$(13)="KARYO"
opponent$(14)="CRAWFORD"
opponent$(15)="FIENNES"
opponent$(16)="MARIS"
opponent$(17)="DOUGLAS"
opponent$(18)="BABBITT"

Dim trackname$(3)
trackname$(1)="SIMPLE OVAL"
trackname$(2)="FOREST RACEWAY"
trackname$(3)="SPEED CIRCUIT"

Dim time_name$(5)
time_name$(1)="Gibson"
time_name$(2)="Pickford"
time_name$(3)="Ullman"
time_name$(4)="Lawson"
time_name$(5)="Chase"

Dim recname$(racetracks,8,5)
Dim records(racetracks,8,5)
Dim defaults(racetracks,8,5)

Data 94,96,99,102,105
Data 105,108,112,116,120

Data 360,370,380,390,400
Data 150,155,160,165,170

Data 500,520,540,560,580
Data 160,165,170,175,180

dn=laprace*4+mirror*2+reverse+1

For dm=1 To racetracks
For dn=1 To 8
For dp=1 To 5

recname$(dm,dn,dp)=time_name$(dp)

If (dn Mod 4)=1
Read records(dm,dn,dp)
If dn=1 Then records(dm,dn,dp)=records(dm,dn,dp)*100
If dn=5 Then records(dm,dn,dp)=records(dm,dn,dp)*1000
EndIf

If (dn Mod 4)<>1 Then records(dm,dn,dp)=records(dm,dn-1,dp)

defaults(dm,dn,dp)=records(dm,dn,dp)

Next
Next
Next


Dim car_texture(6)

For bz=1 To 6
car_texture(bz)=LoadTexture("stock/altcar"+bz+".jpg")
Next

Dim laptime$(50)

Dim laprecord(10,2)

Dim carcol(10,3)
Data 255,255,255
Data 255,0,0
Data 0,0,255
Data 128,64,0
Data 0,0,0
Data 0,255,255
Data 255,0,255
Data 255,128,0
Data 255,200,0
Data 0,255,0

For k=1 To 10
For l=1 To 3
Read carcol(k,l)
Next
Next

Dim camviews#(9,6)
Data 5,-12,0.15,0,0,1
Data 2.5,-6,0.3,0,0,1
Data 2,-4,0.5,0,0,0.2
Data 1,1,1,1,2,0.1
Data 0.2,3,1,0.2,4,0.1
Data 20,0,1,0,0,0.1
Data 200,0,1,0,0,0.1
Data 0,0,0,0,0,0.1
Data 1,5,1,1,-5,0.1

For kp=1 To 9
For kq=1 To 6
Read camviews#(kp,kq)
Next
Next

Dim viewname$(9)
viewname$(1)="Chase Cam - High"
viewname$(2)="Chase Cam - Medium"
viewname$(3)="Chase Cam - Close"
viewname$(4)="Bonnet Cam"
viewname$(5)="Speed Cam"
viewname$(6)="High Cam"
viewname$(7)="Very High Cam"
viewname$(8)="Stationary Cam"
viewname$(9)="Reverse Cam"

Global cam_view=1

Dim texco#(4)
Data 0,0.1,0.9,1
For aa=1 To 4
Read texco#(aa)
Next

Dim ghost#(10,4,1000,6)
Dim pre_ghost#(10000,6)
Dim ghost_filesize(10,4)
Dim ghost_frames(10,4)

Dim gchecktime(10,4,20)
Dim pchecktime(20)

Dim stpos(6)
Dim pre_stpos(6)
;controls pressed by the ghost car

;10 = track number
;10000 = frame number (10000/75 = Over 2 Minutes)

;values range from 0 to 15 ( co_for*8 + co_rev*4 + co_left*2 + co_right)


Global font=LoadFont("helvetica",14,True)
Global font2=LoadFont("helvetica",30,True)
Global font3=LoadFont("helvetica",100,True,True)

Global sidebar=LoadImage("stuff/sidebar.bmp")
ScaleImage sidebar,2,2

Global pointer=LoadImage("stuff/pointer.bmp")
Global option=1,chosen=0,boxpoint=1

Global musc=0

Dim mainmenu$(5)
mainmenu$(1)="ARCADE"
mainmenu$(2)="TIME TRIAL"
mainmenu$(3)="FREE RUN"
mainmenu$(4)="WATCH MODE"
mainmenu$(5)="OPTIONS"

Dim tmapdata#(10000,3)


smoke=LoadTexture("stuff/smoke1.bmp",4)

maskit(smoke,2)

Global fume=CreateSprite()
;fumesurf=CreateSurface(fume)
EntityTexture fume,smoke
;newrect(fumesurf,0,0,0,0.5,0.5,0,0,1,1,1,0)
;AddVertex fumesurf,0.5,0.5,1
;FitMesh fume,-1,-1,-0.1,2,2,0.2



HideEntity fume

Global terr

Global tracknum=2
If inair=1 Then HideEntity terr

Global night=0

Global skybox

If night=0 Then skybox=makeskybox("skytex2/bluesea","bmp")
If night=1 Then skybox=makeskybox("night/sky08","jpg")



starts=LoadTexture("stuff/startsign.jpg")

Global stgate=CreateMesh()
msurf=CreateSurface(stgate)
EntityTexture stgate,starts

newrect(msurf,0.05,0.4,0,0.01,0.4,0,0.75,1,1,2,0)
newrect(msurf,0.95,0.4,0,0.01,0.4,0,0.75,1,1,2,0)
newrect(msurf,0.5,0.9,0,0.5,0.1,0,0,1,0.75,1,0)

AddVertex msurf,0.5,0.5,1

FitMesh stgate,-20,0,0,40,20,1
PositionEntity stgate,0,20,0


Global map=CreateTexture(200,200,4)


;-- create tree from which to copy during road creation--

tree=LoadTexture("stuff/palmtree.jpg",4)

maskit(tree,1)

Global palmtree=CreateMesh()

EntityTexture palmtree,tree
EntityType palmtree,NOCOL

palmsurf=CreateSurface(palmtree)

For vv=0 To 120 Step 60
newrect(palmsurf,0.5,0.5,0,0.5,0.5,0,0,1,1,1,vv)
;add triangles to tree
Next


FitMesh palmtree,-5,0,-5,10,15,10
EntityBox palmtree,-1.5,0,-1.5,3,15,3

HideEntity palmtree

;--end of tree creation--



watertex=LoadTexture("stuff/textures/water.bmp")

Global waterlev#=-0.5
;makeplane(2000,50,tex,-0.5,1)
Global plane=CreateMesh()
Global psurf=CreateSurface(plane)

EntityTexture plane,watertex


Global spoke=LoadTexture("stock/tyre2.jpg");("stuff/spoke2.bmp")

Type smokering
Field smoke_ent,side,disp#
End Type

Type scenery
Field ent,collon,collset
End Type

Type rtunnel
Field ent
End Type

Type vehic
Field car,num,speed#,prev_x#,prev_y#,prev_z#
Field wturn#,wrot#,onground,forward#
Field wheels[4]
Field onpiece,reverse,accel#,recover
Field update,ahead,rubble,onscene
Field place,lap,maintain,lockout
Field notice#,spturn#
Field transx#,transy#,transz#,fromcent#
Field pivot[3]
Field see,dropping,sunk,carpivot
Field centpivot,offroad,smoking
Field inslide,movedon,scenecoll
Field isonscene,exdist#,yup#
Field unlapped ;prevents cheating

Field rem_recover,rem_offroad
Field rem_sunk,rem_onscene
Field rem_movedon

End Type

Type name
Field player$
End Type




Dim weely#(4)

Global roadpivot=CreatePivot()


;Global car=LoadMesh( "car.x" )
Global car=LoadMesh("stock/high.3ds")
ScaleMesh car,1,1,-1
FlipMesh car
FitMesh car,-1.5,-1.2,-3,3,2.4,6
EntityBox car,-2,-1,-4,4,2,8
EntityRadius car,1
PositionEntity car,0,100,0
EntityShininess car,1
EntityType car,BODY

Global carsurf=GetSurface(car,1)


HideEntity car


Global ghost_car


Global nnn=CountSurfaces(car)
ttt=GetSurface(car,1)
Global sss=CountTriangles(ttt)


;Global whel=CreateCylinder(8,True)
Global whel=CreateMesh()
whelsurf=CreateSurface(whel)

segs=16

For ra=1 To 2

AddVertex whelsurf,0,ra*2-3,0,0.5,0.5

vv=CountVertices(whelsurf)

For rc=1 To segs

ang=rc*360/segs

AddVertex(whelsurf,Sin(ang),ra*2-3,Cos(ang),0.5+0.5*Sin(ang),0.5+0.5*Cos(ang))

If rc>1
ww=CountVertices(whelsurf)

If ra=2
AddTriangle whelsurf,vv-1,ww-2,ww-1
If rc=segs Then AddTriangle whelsurf,vv-1,ww-1,vv
EndIf

If ra=1
AddTriangle whelsurf,vv-1,ww-1,ww-2
If rc=segs Then AddTriangle whelsurf,vv-1,vv,ww-1
EndIf
EndIf

Next
Next


For rd=1 To segs

rdd=rd+1
If rd=segs Then rdd=1

AddTriangle whelsurf,rd,rdd,rd+segs+1
AddTriangle whelsurf,rdd,rdd+segs+1,rd+segs+1

Next


EntityTexture whel,spoke
ScaleEntity whel,.7,.2,.7
EntityRadius whel,.6
HideEntity whel

Global wheels[4]

Global road=CreateMesh()
EntityType road,TARMAC

Global surface=CreateSurface(road)
Global track ;road texture


Global racingline=CreateMesh()
Global racelinesurf=CreateSurface(racingline)
EntityColor racingline,255,0,0
HideEntity racingline

Global grid=CreateMesh()
Global gridsurf=CreateSurface(grid)
;EntityOrder grid,-5


Global wallbar=LoadTexture("stuff/wallbar.bmp",4)
;wallbar=LoadTexture("stuff/chevron.bmp")


Global wall1=CreateMesh() ;wall on left of road
EntityType wall1,STRUCT
Global w1surf=CreateSurface(wall1)
EntityTexture wall1,wallbar

Global wall2=CreateMesh() ;wall on right of road
EntityType wall2,STRUCT
Global w2surf=CreateSurface(wall2)
EntityTexture wall2,wallbar


Global roady#=0,gmode=0,rdx#=0.1,count,d_ang#,ryc#,obst
Global loadedtrack=0


Global camera=CreateCamera()

CameraRange camera,0.2,1000
CameraClsColor camera,75,150,255
PositionEntity camera,0,50,-50

;setupblurcamera(camera,0.5)

;CameraClsColor camera,128,255,255
;CameraClsMode camera,0,1

Global filter=CreateSprite(camera)
PositionEntity filter,0,0,1
EntityOrder filter,-2

Global filter2=CreateSprite(camera)

PositionEntity filter2,0.96,1.16,2
ScaleSprite filter2,0.16,0.32
EntityAlpha filter2,0

.init_map

Global coursemap=CreateMesh(camera)

Global cmapsurf=CreateSurface(coursemap)
newrect(cmapsurf,0,0,0,1,1,0,0,1,1,1,0)
AddVertex cmapsurf,0,0,1


HideEntity coursemap

Global numsprite=CreateSprite(camera)
SpriteViewMode numsprite,2
HideEntity numsprite

Global numtexture=CreateTexture(100,100,4)

Global turnsprite=newsprite("turn",1,0.2)
Global boundsprite=newsprite("bounds",1,0.2)

Global pulse=0



Global mposx#=-2.25,mposy#=-1.75,mposz#=3
;mposx#=-2.8:mposy#=-2.2:mposz#=3.75

PositionEntity coursemap,mposx#,mposy#,mposz#
EntityOrder coursemap,-1

Global mapcentx#=320+mposx#*320/mposz#
Global mapcenty#=240-mposy#*320/mposz#
Global mapsize#=640/mposz#


Global white=LoadTexture("stuff/white.bmp",64)
EntityTexture filter,white
EntityTexture filter2,white

EntityColor filter2,0,0,255

Global camshadow=CreatePivot(camera)

For ka.vehic = Each vehic
ka\speed#=0
ka\prev_x#=EntityX( ka\car )
ka\prev_y#=EntityY( ka\car )
ka\prev_z#=EntityZ( ka\car )
Next

Global x_vel#=0,y_vel#=0,z_vel#=0,incols=0

UpdateWorld()

docollisions()

Global frams,frate=MilliSecs(),tframs

If night=0 Then AmbientLight 255,255,255
If night=1 Then AmbientLight 64,64,64

Global scount,stotal


;Global announcer=LoadSound("stuff/sfx/startengines.wav")
;SoundVolume announcer,0.7
Global zoomout#=25
Global ingame=0,pausemenu=0,gamestate=0,do_reset=0
Global pausesol=0
Global startengines

Global sepia=0

Dim odxy#(racetracks,2) ;offsets - loaded in load() if previously created


new_scene()

createcars(1)

load() ;load records()

racetracks=3 ;was set to to in load()
;change racetracks here to introduce new track

Global target

ocar.vehic=Object.vehic(yourcar)

target=CreatePivot(ocar\carpivot)
PositionEntity target,0,camviews#(cam_view,1),camviews#(cam_view,2)
EntityType target,NOCOL

basecar()

ghost_car=CopyEntity(newcar)
EntityTexture ghost_car,car_texture(1)
EntityAlpha ghost_car,0.5
EntityType ghost_car,NOCOL
HideEntity ghost_car

Dim ghostwheel(4)

cnt=1

For z#=1.7 To -1.7 Step -3.4
For x#=-1.5 To 1.5 Step 3	
			
	ghostwheel(cnt)=CopyEntity(whel,ghost_car)
		
	TurnEntity ghostwheel(cnt),0,0,90
	PositionEntity ghostwheel(cnt),x#,-1,z#
	
	EntityType ghostwheel(cnt),NOCOL
	EntityAlpha ghostwheel(cnt),0.5
	
	axle=CreateCube(ghostwheel(cnt))
	
	EntityColor axle,0,0,0
	ScaleEntity axle,0.2,2,0.2
	PositionEntity axle,0,x#,0
		
	cnt=cnt+1
Next
Next


.track_map

;Dim trackstart(racetracks,2)
;Data 


Global maptemp=CreateImage(10,10)

Dim maptex(racetracks)

Dim t_size#(racetracks,2)


For vv=1 To racetracks

active=0
If Not(FileType("maps/map"+vv+".bmp")) Then active=1
If odxy#(vv,1)=0 And odxy#(vv,2)=0 Then active=1

createmap(vv,active)

maptex(vv)=LoadTexture("maps/map"+vv+".bmp",4)
maskit(maptex(vv),4)

FreeImage maptemp
maptemp=LoadImage("maps/map"+vv+".bmp")

t_size#(vv,1)=ImageWidth(maptemp)*1.2
t_size#(vv,2)=ImageHeight(maptemp)*1.2

Next

SetBuffer BackBuffer()



Repeat


If KeyHit(31) Then savescreenshot()


toglim=2
If numcars>10 And gamestate=1 And frams>5

ddrate#=((MilliSecs()-frate)*10)/frams
If ddrate#>150 Then toglim=3

EndIf

toggle=toggle+1
If toggle>=toglim
toggle=0
framtot=framtot+1
If toglim=3 Then fram3=fram3+1

EndIf
;EndIf

If pausemenu=0
If gamestate=1 Then game()
EndIf

	If toggle=1 ;And gamestate+sepia>0
	UpdateWorld	
	RenderWorld
	EndIf
	
	If gamestate=1 Then pauseit()

	If gamestate=1 Then twodeedata()
	
	If gamestate=0 Then titles()

	
		
	WaitTimer my_timer	
	If toggle=1
	Flip	
	Cls
	EndIf
			
	gamestate=ingame
Until False

End


Function game()



If countnum<=0
If ChannelPlaying(musc)=False
If ochoice(3)=1 Then musc=PlayMusic("module.mod")
EndIf
EndIf

PositionEntity skybox,EntityX(camera),0,EntityZ(camera)

scount=0
stotal=0


For anitem.scenery = Each scenery
;UpdateNormals anitem\ent
anitem\collset=0
If anitem\collon=1 Then scount=scount+1
stotal=stotal+1
Next

For ring.smokering = Each smokering
PositionEntity ring\smoke_ent,0.7*ring\side,-0.7+ring\disp#*0.2,-3-ring\disp#

rscale#=(1+ring_disp#)*0.5
ScaleSprite ring\smoke_ent,rscale#,rscale#
EntityAlpha ring\smoke_ent,1-ring\disp#*0.2

ring\disp#=ring\disp#+0.2

If ring\disp#>=4
FreeEntity ring\smoke_ent
Delete ring
EndIf

Next


If zoomout#>0
zoomout#=zoomout#-0.1
If zoomout#<=0

EntityAlpha filter2,0.5

countdown=MilliSecs()
countnum=3
PlaySound t3
If sepia=0
ShowEntity numsprite
update_num()
EndIf
If sepia=1 Then countnum=-1

EndIf

EndIf




alpha#=zoomout#/20
If alpha#>1 Then alpha#=1

If sepia=0 And alpha#>0
EntityAlpha filter,alpha#
EntityColor filter,255,255,255
EndIf


If Int(zoomout#*10)=180
If numcars>6
;startengines=PlaySound(announcer)
EndIf
EndIf

If Int(zoomout#*10)=230 Then createcars(0)


If incols>0 Then incols=incols+1

If racestart=0 And incols=3
docollisions()
incols=0
EndIf

do_reset=0



;If controls=2

If allcpu=0 Then lastview=5 Else lastview=9

If JoyHit(8) And newview<lastview Then newview=newview+1
If JoyHit(7) And newview>1 Then newview=newview-1
;EndIf



	frams=frams+1
	
	If MilliSecs()-frate>1000
	frate=frate+1000
	tframs=frams
	
	If tframs<75 Then frameslost=frameslost+75-tframs
	
	frams=0
	EndIf


	If allcpu=1
	precar=playercar
	menupointer(0,-50,0,numcars,1,1)	
	playercar=numcars+2-option
	If option=1 Then playercar=1
	
	If playercar<>precar Then change=1	
	EndIf

	
	scenetween=scenetween+1
	If scenetween=5 Then scenetween=0
		
	For gcar.vehic = Each vehic
	
.start_of_first_car_loop
	
	If EntityCollided(gcar\car,TUNSTRUCT)
	
	findverts(gcar\onpiece,EntityYaw(gcar\car)-90)
	
	ttt=Sgn(gcar\fromcent#)
	If Abs(road_angle#)>90 Then ttt=-ttt ;wrong way	
	
	;gcar\spturn#=gcar\spturn#-Abs(gcar\speed)*0.2*ttt
	TurnEntity gcar\car,0,Abs(gcar\speed)*ttt,0
	gcar\speed=gcar\speed*0.99
	
	EndIf
	
	If gcar\num=playercar Then yourcar=Handle(gcar)

	;findverts(gcar\onpiece)
	
	;vectx#=EntityX(gcar\car)-(vx#(1)+vx#(2))/2
	;vecty#=EntityY(gcar\car)-(vy#(1)+vy#(2))/2
	;vectz#=EntityZ(gcar\car)-(vz#(1)+vz#(2))/2
	
	;vectmag#=(vectx#^2+vecty#^2+vectz#^2)^0.5
	;force#=0.1
	
	;If vectmag#>10
	;TranslateEntity gcar\car,-vectx#*force#/vectmag#,-vecty#*force#/vectmag#,-vectz#*force#/vectmag#
	;EndIf
		
	;offheight#=EntityY(gcar\car)-TerrainY(terr,EntityX(gcar\car),EntityY(gcar\car),EntityZ(gcar\car))
	
		
	gcar\isonscene=0	
	If EntityCollided( gcar\car,SCENE ) Then gcar\isonscene=1
	If EntityCollided( gcar\car,TARMAC) Then gcar\isonscene=2
	;If gcar\isonscene=1 Then gcar\isonscene=2
	
	onscene=gcar\isonscene	
	
	
	
	If gcar\num=playercar
	
	If gcar\lap>0
	
	sumofspeed=sumofspeed+(gcar\speed)*convert
	countspeed=countspeed+1
	
	EndIf
	
	
	If gcar\onpiece<20 Then nextcheck=1
	
	
	If gcar\onpiece=nextcheck*80
	
	pchecktime(nextcheck)=MilliSecs()-laptimer
		
	lagg=pchecktime(nextcheck)-gchecktime(tracknum,mirror*2+reverse+1,nextcheck)
	
	If allcpu=0 Then showlagg=100
	
	nextcheck=nextcheck+1
	
	EndIf
	
		
	
	If change=1
	change=0
	EntityParent target,gcar\carpivot
	PositionEntity target,0,camviews#(cam_view,1),camviews#(cam_view,2)
	EndIf
	
	yyy#=EntityY(target,True)-TerrainY(terr,EntityX(target,True),EntityY(target,True),EntityZ(target,True))
	If yyy#<0 And onscene>0 Then targ=-targ
		
	;view car side when car is turning
	RotateEntity gcar\carpivot,0,(gcar\spturn#*30),0
	
	PositionEntity target,0,targ*camviews#(cam_view,1)+zoomout#*camviews#(2,1),camviews#(cam_view,2)+zoomout#*camviews#(2,2)
	
	EndIf
	
	
	
	
		
	onroof=1
	oturn#=wturn#
	
	
	If Abs(EntityRoll(gcar\car))<60 And Abs(EntityPitch(gcar\car))<60 Then onroof=0
			
	
	If Abs(gcar\fromcent#)<=trackwid Or onscene=2 Then gcar\offroad=MilliSecs()
	
	;If Abs(gcar\fromcent#)>8
	
	For anitem.scenery = Each scenery
	
	If xydistance#(gcar\car,anitem\ent)<10	
	anitem\collset=1	
	EndIf
	
	Next
		
	;EndIf
	
	
	
	
	If EntityCollided(gcar\centpivot,SIDE)
	If gcar\fromcent#>0 Then xdd#=-1 Else xdd#=1
	MoveEntity gcar\car,xdd#,0,0
	gcar\speed=gcar\speed*0.99
	gcar\lockout=1
	EndIf
	
	
	If onscene>0 And racestart=1 Then gcar\dropping=0
	;If gcar\dropping=1 Then TranslateEntity gcar\car,0,-1,0	
		
	If onroof=0 And gcar\maintain=0 Then cartowheels(gcar.vehic)
	
	If gcar\maintain>0
	gcar\maintain=gcar\maintain-1
	For uu=1 To 4
	ResetEntity gcar\wheels[uu]
	Next
	
	EndIf
	
	;calculate car velocities	
	cx#=EntityX( gcar\car ):x_vel=cx-gcar\prev_x:gcar\prev_x=cx
	cy#=EntityY( gcar\car ):y_vel=cy-gcar\prev_y:gcar\prev_y=cy
	cz#=EntityZ( gcar\car ):z_vel=cz-gcar\prev_z:gcar\prev_z=cz
	
	
	If gcar\lockout>0 ;Or gcar\dropping=1
	;PositionEntity gcar\car,cx#,TerrainY(terr,cx#,cy#,cz#),cz#
	x_vel=0
	y_vel=0
	z_vel=0
	gcar\lockout=gcar\lockout-1	
	EndIf
	
	
	carvel#=(x_vel^2+y_vel^2+z_vel^2)^0.5
	
	
	hitstruct=0
	
	If EntityCollided(gcar\car,STRUCT) Then hitstruct=1
	If EntityCollided(gcar\car,BOXSTRUCT) Then hitstruct=1
	
	If hitstruct=1
	;ResetEntity gcar\car
	;If Abs(carvel#)<Abs(gcar\speed) Then gcar\speed=carvel#
	gcar\speed=gcar\speed*0.99	
	EndIf
		
		
	
	ohdear=0
	
	For hx=1 To 4
	
	above#=EntityY(gcar\car)-EntityY(gcar\wheels[hx],True)
	If above#<0 Then ohdear=ohdear+1
	
	Next
	
	
	resp#=(carvel#+0.1)/(Abs(gcar\speed#)+0.1)

	
	If onroof=0	And ohdear<4;And carstuck=0 And highest-lowest#<2
	;If resp#>0.5 Or carvel#<0.2 Or gcar\speed<0.2	
	gcar\recover=MilliSecs()	
	;EndIf	
	EndIf
	
	If EntityY(gcar\car)>-1 Then gcar\sunk=MilliSecs()
	
	If onscene>0 And gcar\reverse=0
	If gcar\speed#>carvel#*5 And gcar\speed#>.5
	If gcar\num<>playercar Or allcpu=1 Then gcar\reverse=100
	EndIf
	EndIf
	
	If gcar\reverse>0
	If gcar\num<>playercar Or allcpu=1
	gcar\reverse=gcar\reverse-2
	If onscene>0 And gcar\reverse>50
	If gcar\speed>0 Then gcar\speed=0
	gcar\speed=gcar\speed-.02
	
	EndIf
	EndIf
	EndIf
	
		
	If onscene>0 And MilliSecs()-gcar\onscene>500
	gcar\transx#=gcar\transx#+x_vel*1
	gcar\transy#=-1
	gcar\transz#=gcar\transz#+z_vel*1
	
	EndIf
	
	If onscene>0 Then gcar\onscene=MilliSecs()
		
	;gcar\speed=gcar\speed+(carvel#-gcar\speed)*0.05
	;carvel#=5	
	repwheels(gcar.vehic)


	;move car
	co_left=0:co_right=0:co_for=0:co_rev=0
	
	canrace=0
	If countnum<=0 Then canrace=1
	
	If onroof=0
	If canrace=1 Then followroad(gcar.vehic,1)
	EndIf
	
	If gcar\num=playercar
	
	carx#=EntityX(gcar\car)
	cary#=EntityY(gcar\car)
	carz#=EntityZ(gcar\car)
	carpi#=EntityPitch(gcar\car)
	carya#=EntityYaw(gcar\car)
	carro#=EntityRoll(gcar\car)
	
	roadcam=((gcar\onpiece+10)/20)*20
	snapview=0
	
	lastview=5
	If allcpu=1 Then lastview=9
	lastview=9
	
	For views=1 To lastview
	fix=0
	If KeyHit(views+1) Then fix=1
	If cam_view<>newview And newview=views Then fix=1
	
	If fix=1
	snapview=1
	cam_view=views
	newview=views
	PositionEntity gcar\ahead,0,camviews#(views,4),camviews#(views,5)
		
	
	EndIf
	
	Next
	
	
	
	If KeyDown(72) Then skycamy#=skycamy#+1
	If KeyDown(80) Then skycamy#=skycamy#-1
	
	If KeyDown(75) Then skycamx#=skycamx#-1
	If KeyDown(77) Then skycamx#=skycamx#+1
	
	
	
	
	If allcpu=1 And zoomout#<=0 Then racestart=1
	
	If allcpu=0
	
	;If controls=1
	If KeyDown(203) Then co_left=1
	If KeyDown(205) Then co_right=1
	If KeyDown(200) Then co_for=1	
	If KeyDown(208) Then co_rev=1
	;EndIf
	
	
	
	;If controls=2
	
	;If JoyHat=0 Or JoyHat=45 Or JoyHat=315 Then co_for=1
	;If JoyHat=135 Or JoyHat=180 Or JoyHat=225 Then co_rev=1
	If JoyDown(2) Then co_for=1
	If JoyDown(1) Then co_rev=1
	
	If JoyHat()=45 Or JoyHat()=90 Or JoyHat()=135 Then co_right=1
	If JoyHat()=225 Or JoyHat()=270 Or JoyHat()=315 Then co_left=1
	If JoyXDir()=-1 Then co_left=1
	If JoyXDir()=1 Then co_right=1
	 
		
	;EndIf
	
	EndIf
	
	EndIf
	
	
	
	distx#=EntityX(gcar\car)-EntityX(camera);carx#
	disty#=EntityY(gcar\car)-EntityY(camera)
	distz#=EntityZ(gcar\car)-EntityZ(camera)
	distaway#=(distx#^2+disty#^2+distz#^2)^0.5
	
	engine=0
	If co_for=1 Then engine=1
	
	If engine=1
	envol#(gcar\num)=1
	
	If MilliSecs()-gcar\smoking>100
	
	
	If aak=1
	
	For nring=-1 To 1 Step 2
	
	If nring=-1 Then nring=1
	
	s_ring.smokering = New smokering
	
	s_ring\smoke_ent=CopyEntity(fume)
	
	EntityParent s_ring\smoke_ent,gcar\car
	
	ScaleSprite s_ring\smoke_ent,0.2,0.2
	
	s_ring\side=nring
	s_ring\disp#=0
		
	PositionEntity s_ring\smoke_ent,0.7*nring,-0.7,-3
	
	gcar\smoking=MilliSecs()
	
	Next
	
	EndIf
	
	EndIf
	
		
	EndIf
	
	
	
	If engine=0 And envol#(gcar\num)>0.2 Then envol#(gcar\num)=envol#(gcar\num)-0.01
	volume#=envol#(gcar\num)*1.5*(0.95)^distaway#
	If volume#>1 Then volume#=1
	
	If zoomout#>20 Then volume#=0
	If sepia=1 Then volume#=0.5
	
	ChannelVolume car_engine(gcar\num),volume#*0.2
	ChannelPitch car_engine(gcar\num),(gcar\speed*9000)+6000
	
	anglefrom#=calc_ang#(distx#,distz#,carya#)
	If gcar\num=playercar Then pan#=0 Else pan#=Sin(anglefrom#)
	
	ChannelPan car_engine(gcar\num),pan#
	
	urate#=0.04;(Abs(gcar\speed)^0.5)*0.05
	If gcar\num<>playercar Or allcpu=1
	
	dfact#=1+(ochoice(1)-1)*0.1
	
	urate#=enemybase#(tracknum,2)*dfact#
	
	EndIf
	
	
	If onscene=1 Then urate#=urate#*2
	;If co_for=0 Then urate#=urate#*(1+gcar\speed)
	against#=(co_right-co_left)*gcar\spturn#
	f_fact#=Abs(gcar\spturn#)*0.1+0.01
	
	If against#<0 Then urate#=urate#*(0.1)^Abs(against#)
	If against#<0 Then spfrict#=1
	If against#>0 Then spfrict#=1-f_fact#*1
	If against#=0 Then spfrict#=1-f_fact#*0.5
	
	If co_for=0 And co_left-co_right=1 Then gcar\inslide=1
	If co_for=0 And co_right-co_left=1 Then gcar\inslide=2
	
	If gcar\inslide=1 And co_left-co_right<1 Then gcar\inslide=0
	If gcar\inslide=2 And co_right-co_left<1 Then gcar\inslide=0

	If gcar\inslide>0 Then spfrict#=1-((1-spfrict#)/(2))
	
	;If Abs(gcar\spturn#)>5 Then End


	If co_left=1
	gcar\wturn#=gcar\wturn#+3
	gcar\spturn#=(gcar\spturn#*1)-urate#
	EndIf
	
	If co_right=1
	gcar\wturn#=gcar\wturn#-3
	gcar\spturn#=(gcar\spturn#*1)+urate#
	EndIf
	
	
	If gcar\num=playercar And gcar\lap>0 And sepia=0 And framenum<=10000
	
	;record car positions for ghostcar
	
	fra=framenum
	ghostlen=ghost_frames(tracknum,mirror*2+reverse+1)
	ghostsize=ghost_filesize(tracknum,mirror*2+reverse+1)
	
	tra=tracknum
	
	pre_ghost(fra,1)=EntityX(gcar\car)
	pre_ghost(fra,2)=EntityY(gcar\car)
	pre_ghost(fra,3)=EntityZ(gcar\car)
	pre_ghost(fra,4)=EntityPitch(gcar\car)
	pre_ghost(fra,5)=EntityYaw(gcar\car)
	pre_ghost(fra,6)=EntityRoll(gcar\car)
	
	stick=fra
	If ghostlen<stick And ghostlen>0 Then stick=ghostlen
	
	ccrem=stick Mod ghostween
	cc=(stick-ccrem)/ghostween
	If cc>=ghostsize-1 Then cc=ghostsize-1:ccrem=0 
	
	
		
	PositionEntity ghost_car,ghostcalc#(cc,ccrem,1),ghostcalc#(cc,ccrem,2),ghostcalc#(cc,ccrem,3)
	
	RotateEntity ghost_car,ghostcalc#(cc,ccrem,4),ghostcalc#(cc,ccrem,5),ghostcalc#(cc,ccrem,6)
	
	For ff=1 To 4
	RotateEntity ghostwheel(ff),gwturn,0,90
	Next
	
	gwturn=gwturn+10
	If gwturn>=360 Then gwturn=gwturn-360
	
	framenum=framenum+1	
	
	showghost=0
	If ghost_filesize(tracknum,mirror*2+reverse+1)>0 And gcar\lap>0 And numcars=1 Then showghost=1
	If showghost=0 Then HideEntity ghost_car
	If showghost=1 Then ShowEntity ghost_car
	
	EndIf
	
	
	
	
	TurnEntity gcar\car,0,-gcar\spturn#,0
	
	gcar\spturn#=gcar\spturn#*spfrict#;0.90+(gcar\spturn#)*0.05	
	gcar\wturn#=gcar\wturn#*0.9
		
	
	For ii=1 To 4
	turn#=gcar\wturn#
	If ii=3 Or ii=4 Then turn#=0
	
	RotateEntity gcar\wheels[ii],gcar\wrot#,turn#,90
	Next
	
	
	
	pre_ground=gcar\onground
	gcar\onground=onscene
	;use this line to fix wheels while stationary
	If pre_ground=0 And gcar\onground>0 And racestart=0 Then MoveEntity gcar\car,0,0,0.01

		
	If onscene>0
	
	
		If co_for=1 And countnum<=0
		
		;If racestart=0 Then laptimer=MilliSecs()		
		racestart=1
		gcar\speed=gcar\speed+gcar\accel#*accel#
		
		EndIf
		
		If co_rev=1
		;If gcar\speed>0 Then rev#=.005 Else rev#=.0025*accel# 
		rev#=.0025
		gcar\speed=gcar\speed-rev#	
		EndIf
			
		
		If onscene=2 Then spless#=0.995+(gcar\speed*0.002)
		If onscene=1 Then spless#=0.98
		
		;If co_for=0 Then spless#=spless#^2
		
		spless#=1-(1-spless#)*accel#
		
		gcar\speed=gcar\speed*spless#
		If onroof=0 Then MoveEntity gcar\car,0,0,gcar\speed
		
				
		If onscene>0 And onroof=1
		
		gi#=EntityPitch(gcar\car)
		pturn#=0:rturn#=0
		If gi#>5 Then pturn#=(gi#)*0.5
		If gi#<-5 Then pturn#=(gi#)*0.5
		
		gj#=EntityRoll(gcar\car)
		If gj#>0 And gj#<175 Then rturn#=(180-gj#)*0.05
		If gj#<0 And gj#>-175 Then rturn#=(-180-gj#)*0.05
				
		TurnEntity gcar\car,pturn#,0,rturn#
				
		EndIf
		
		
		pp#=EntityPitch(gcar\car)
		rr#=EntityRoll(gcar\car)
		
		If pp#>90 Then pp#=180-pp#
		If pp#<-90 Then pp#=-180-pp#
		If rr#>90 Then rr#=180-rr#
		If rr#<-90 Then rr#=-180-rr#
		
		If onscene=1 Then factr#=0.5
		If onscene=2 Then factr#=0.2
		If racestart=0 Or gcar\speed=0 Then factr#=0
		
		dfa#=(1-Cos(pp#))*Sgn(pp#)*factr#
		dfb#=(1-Cos(rr#))*Sgn(rr#)*factr#
		
		If Abs(dfa#)<0.01 Then dfa#=0
		If Abs(dfb#)<0.01 Then dfb#=0
		
		If gcar\speed>0.01
				
		MoveEntity gcar\car,dfb#*GRAVITY#*100,0,-dfa#*GRAVITY#*200
		
		EndIf
		
		gcar\speed=gcar\speed-dfa#*GRAVITY#*5*gcar\speed
			
	
		gcar\wrot#=gcar\wrot#+gcar\speed*50	
		
		TranslateEntity gcar\car,0,GRAVITY,0
	Else
	
		gcar\wrot#=gcar\wrot#+gcar\speed*25
				
		TranslateEntity gcar\car,x_vel,y_vel+GRAVITY,z_vel
		If EntityY(gcar\car)<-10
		TranslateEntity gcar\car,0,-10-EntityY(gcar\car),0		
		EndIf
		
		
	EndIf
	
	
	
	
	;--start of camera operation--
	

	If gcar\num=playercar
		
	
	du#=EntityY(target,True)-EntityY(gcar\car,True)
	
		dx#=EntityX( target,True )-EntityX( camera )
		dy#=EntityY( target,True )-EntityY( camera )
		dz#=EntityZ( target,True )-EntityZ( camera )
		
		dcc#=camviews#(cam_view,3)
		If MilliSecs()-gcar\offroad>2000 Then dcc#=0
		
		If snapview=1 Then dcc#=1:snapview=0
		
		TranslateEntity camera,dx*dcc#,dy*dcc#,dz*dcc#
		xspeed#=(dx#^2+dy#^2+dz#^2)^0.5
		
		PointEntity camshadow,gcar\ahead
	
	EndIf
	
		
	Next
	
	
		
	If cam_view<6 Or cam_view>7
	
	
	dpitch#=EntityPitch(camshadow,True)-EntityPitch(camera)
	dyaw#=EntityYaw(camshadow,True)-EntityYaw(camera)
	droll#=EntityRoll(camshadow,True)-EntityRoll(camera)
	
	If dpitch#>180 Then dpitch#=dpitch#-360
	If dpitch#<-180 Then dpitch#=dpitch#+360
	If dyaw#>180 Then dyaw#=dyaw#-360
	If dyaw#<-180 Then dyaw#=dyaw#+360
	If droll#>180 Then droll#=droll#-360
	If droll#<-180 Then droll#=droll#+360

	drate#=camviews#(cam_view,6)
	If snapview=1 Then drate#=1
	;If cam_view=6 Then droll#=carol#-EntityRoll(camera)
	
	TurnEntity camera,dpitch#*drate#,dyaw#*drate#,droll#*drate#
	
	EndIf
	
	
	If cam_view=6
	PositionEntity camera,carx#,cary#+50,carz#
	RotateEntity camera,90,carya#,0
	EndIf
	
	EntityOrder racingline,0
	
	If cam_view=7	
	PositionEntity camera,carx#,300,carz#
	RotateEntity camera,90,0,0 	
	EntityOrder racingline,-5
	EndIf
	
	If cam_view=8
	findverts(roadcam)
	PositionEntity camera,(vx#(1)+vx#(2))/2,(vy#(1)+vy#(2))/2+3,(vz#(1)+vz#(2))/2,True
	EndIf
	
	;--end of camera operation--
	
	
	
		
	For gcar.vehic=Each vehic
	
	onscene=gcar\isonscene
	
	If gcar\num=playercar Then yonscene=onscene

	
	If racestart=1 Then keepaway(gcar.vehic)
	
	If endrace=0
	
	newplace=1
	
	For icar.vehic=Each vehic
	add=0
	If icar\lap>gcar\lap Then add=1
	If icar\lap=gcar\lap
	If Sgn(icar\onpiece-gcar\onpiece)*(1-reverse*2)=1 Then add=1
	If icar\onpiece=gcar\onpiece And icar\exdist#<gcar\exdist# Then add=1
	EndIf
	
	newplace=newplace+add
	
	Next
	
	gcar\place=newplace
	
	EndIf
	
	TranslateEntity gcar\car,gcar\transx#,gcar\transy#,gcar\transz#
	dec#=0.95
	If onscene=0 Then dec#=0.1
	
	gcar\transx#=gcar\transx#*dec#
	gcar\transy#=gcar\transy#*dec#
	gcar\transz#=gcar\transz#*dec#
	
	
		
	Next
	
	started=1
	
	theight#=TerrainY(terr,EntityX(camera),EntityY(camera),EntityZ(camera))+2
	If EntityY(camera)<0 Then theight#=0
	
	If theight#>EntityY(camera)
	If yonscene>0 Or theight#=0
	TranslateEntity camera,0,theight#-EntityY(camera),0
	EndIf
	EndIf
	
		
For anitem.scenery = Each scenery
If anitem\collset<>anitem\collon

anitem\collon=anitem\collset
If anitem\collon=1 Then EntityType anitem\ent,BOXSTRUCT
If anitem\collon=0 Then EntityType anitem\ent,NOCOL

EndIf
Next
	
	
End Function


Function cartowheels(gcar.vehic)

;align car to wheels

	zx#=(EntityX( gcar\wheels[2],True )+EntityX( gcar\wheels[4],True ))/2
	zx=zx-(EntityX( gcar\wheels[1],True )+EntityX( gcar\wheels[3],True ))/2
	zy#=(EntityY( gcar\wheels[2],True )+EntityY( gcar\wheels[4],True ))/2
	zy=zy-(EntityY( gcar\wheels[1],True )+EntityY( gcar\wheels[3],True ))/2
	zz#=(EntityZ( gcar\wheels[2],True )+EntityZ( gcar\wheels[4],True ))/2
	zz=zz-(EntityZ( gcar\wheels[1],True )+EntityZ( gcar\wheels[3],True ))/2
	AlignToVector gcar\car,zx,zy,zz,1,0.1
	
	zx#=(EntityX( gcar\wheels[1],True )+EntityX( gcar\wheels[2],True ))/2
	zx=zx-(EntityX( gcar\wheels[3],True )+EntityX( gcar\wheels[4],True ))/2
	zy#=(EntityY( gcar\wheels[1],True )+EntityY( gcar\wheels[2],True ))/2
	zy=zy-(EntityY( gcar\wheels[3],True )+EntityY( gcar\wheels[4],True ))/2
	zz#=(EntityZ( gcar\wheels[1],True )+EntityZ( gcar\wheels[2],True ))/2
	zz=zz-(EntityZ( gcar\wheels[3],True )+EntityZ( gcar\wheels[4],True ))/2
	AlignToVector gcar\car,zx,zy,zz,3,0.1
	
	
	cnt=0
	
	If onscene>0
	
	For iu=1 To -1 Step -2
	For iv=-1 To 1 Step 2
	
	cnt=cnt+1
	
	kga#=(EntityX(gcar\wheels[cnt])-iv*1.7)*iv
	kgb#=(EntityY(gcar\wheels[cnt])+1.2)*-1
	kgc#=(EntityZ(gcar\wheels[cnt])-iu*2)*iu
	
	kdiff#=(kga#^2+kgb#^2+kgc#^2)^0.5
	If kdiff#>3 Then ResetEntity gcar\wheels[cnt]
	
	If kga#<0 Then kga#=0
	If kgb#<0 Then kgb#=0
	If kgc#<0 Then kgc#=0
	
	MoveEntity gcar\car,kga#*iv,kgb#*-1,kgc#*iu
	
		
	Next
	Next
	
	EndIf
	
End Function


Function repwheels(gcar.vehic)

;resposition wheels
	cnt=1
	For z#=1.7 To -1.7 Step -3.4
	For x#=-1.5 To 1.5 Step 3				
		PositionEntity gcar\wheels[cnt],x#,-1,z#
		cnt=cnt+1
	Next
	Next
	
End Function

Function createcars(full)

;full=1 actually creates the cars
;full=0 just resets their attributes


bcc=CountVertices(surface)

tks=1
lapon=0

If full=0 Then ClearCollisions()

If full<2 Then tfirst=1:tlast=numcars
If full>1 Then tfirst=0:tlast=0

For nn=tfirst To tlast

carfound=0

If (full Mod 2)=0

For wcar.vehic=Each vehic
If wcar\num=nn
vcar.vehic=wcar.vehic
carfound=1
EndIf
Next


EndIf


If (full Mod 2)=1 Or carfound=0

vcar.vehic = New vehic

If nn=playercar Then yourcar=Handle(vcar)
;If nn=0 Then ghostcar=Handle(vcar)

basecar()

vcar\car=CopyEntity(newcar)


texturenum=(nn Mod 6)
If texturenum=0 Then texturenum=6
EntityTexture vcar\car,car_texture(texturenum)


EntityType vcar\car,BODY;ROAD

;EntityAlpha vcar\car,0

FreeEntity newcar

cnt=1
For z=1.5 To -1.5 Step -3
For x=-1.5 To 1.5 Step 3
			
	vcar\wheels[cnt]=CopyEntity(whel,vcar\car)
	
	PositionEntity vcar\wheels[cnt],x,0,z
	
	TurnEntity vcar\wheels[cnt],0,0,90
	
	EntityType vcar\wheels[cnt],WHEEL;ROAD
	
	axle=CreateCube(vcar\wheels[cnt])
	
	EntityColor axle,0,0,0
	ScaleEntity axle,0.2,1.8,0.2
	PositionEntity axle,0,x,0
	
	;EntityAlpha vcar\wheels[cnt],0
		
	cnt=cnt+1
Next
Next


For kd=1 To 3
vcar\pivot[kd]=CreatePivot(vcar\car)
PositionEntity vcar\pivot[kd],0,0,3-kd*1.5
Next

vcar\centpivot=CreatePivot(vcar\car)
PositionEntity vcar\centpivot,0,0,0
EntityRadius vcar\centpivot,3
;EntityType vcar\centpivot,BODYROAD


vcar\ahead=CreatePivot(vcar\car)
PositionEntity vcar\ahead,0,0,0

vcar\carpivot=CreatePivot(vcar\car)

If full=3 Then EntityAlpha vcar\car,0.5

ScaleEntity vcar\car,carsize,carsize,carsize

If night=1
headlight=CreateLight(3,vcar\car)
PositionEntity headlight,-1,0,2.4
LightConeAngles headlight,0,15
RotateEntity headlight,30,0,0

headlight=CreateLight(3,vcar\car)
PositionEntity headlight,1,0,2.4
LightConeAngles headlight,0,15
RotateEntity headlight,30,0,0
EndIf

EndIf



If reverse=0 Then tracko=(bcc/4)-2-qualpos(nn)
If reverse=1 Then tracko=2+qualpos(nn)
tks=(qualpos(nn) Mod 2)+1

vcar\num=nn
vcar\place=numcars+1-nn
vcar\onground=0
vcar\forward#=0
vcar\lockout=1
vcar\notice#=0
vcar\spturn#=0
vcar\fromcent#=0

vcar\onpiece=tracko
vcar\maintain=0
vcar\transx#=0
vcar\transy#=0
vcar\transz#=0
vcar\lap=lapon
vcar\speed=0
vcar\dropping=1
vcar\scenecoll=0
vcar\isonscene=0
vcar\unlapped=0

vcar\recover=MilliSecs()
vcar\offroad=MilliSecs()
vcar\sunk=MilliSecs()
vcar\onscene=MilliSecs()
vcar\movedon=MilliSecs()

findverts(tracko)

tp#=tks*0.4-0.1
point(tp#)

RotateEntity vcar\car,0,0,0

PositionEntity vcar\car,posx#,TerrainY(terr,posx#,posy#,posz#)+10,posz#


.grid_slot


If nn=1
newverts(0,3,0.5,0.6,0.1,0.05)
EndIf



For grect=1 To 3
newverts(vcar\onpiece,grect,tp#,0.1,0.4,0.02)
Next

tks=tks+1
If tks=3 Then tks=1
tracko=tracko+1*(1-reverse*2)

ds=(vcar\num Mod 10)
If ds=0 Then ds=10
;EntityColor vcar\car,carcol(ds,1),carcol(ds,2),carcol(ds,3)
followroad(vcar.vehic,2)


Next

If full=0 Then incols=1



For wcar.vehic = Each vehic

If wcar\num>numcars

FreeEntity wcar\car
Delete wcar

EndIf

Next



For hh.vehic = Each vehic
;EntityAlpha hh\car,0
If full=1 Then HideEntity hh\car
If full<>1 Then ShowEntity hh\car
Next


End Function


Function createroad(trackname$)

sev=OpenFile(trackname$)
If sev<>0

totverts=ReadInt(sev)
roady#=0

For index=0 To totverts-1

ovx#=verx#
ovy#=very#
ovz#=verz#

verx#=ReadFloat(sev)
very#=ReadFloat(sev)
verz#=ReadFloat(sev)

If mirror=1 Then verx#=-verx#+m_offset#(tracknum)

If index=2
PositionEntity stgate,(verx#+ovx#)/2,(very#+ovy#)/2-5,(verz#+ovz#)/2
sigrol#=ASin((very#-ovy#)/20)*Sgn(very#-ovy#)
sigyaw#=-calc_ang#(verx#-ovx#,verz#-ovz#,0)
RotateEntity stgate,0,90+reverse*180+mirror*180-sigyaw#,0
EndIf

AddVertex surface,verx#,very#,verz#,texco#((index Mod 4)+1),roady#




If index>3

If (index Mod 4)=3

	count=CountVertices(surface)

	;new section of road
	newtri(surface,count,8,4,7,inair)
	newtri(surface,count,7,4,3,inair)
	newtri(surface,count,7,3,6,inair)
	newtri(surface,count,6,3,2,inair)
	newtri(surface,count,6,2,5,inair)
	newtri(surface,count,5,2,1,inair)
	

If (index Mod 24)=7 And dotrees=1

vlx#=VertexX(surface,count-4)
vly#=VertexY(surface,count-4)
vlz#=VertexZ(surface,count-4)

;new tree on left of road
vpx#=vlx#-(verx#-vlx#)*0.1
vpz#=vlz#-(verz#-vlz#)*0.1

item.scenery=New scenery
item\ent=CopyEntity(palmtree)
PositionEntity item\ent,vpx#,TerrainY(terr,vpx#,0,vpz#),vpz#
item\collon=0

;new tree on right of road
vpx#=verx#+(verx#-vlx#)*0.1
vpz#=verz#+(verz#-vlz#)*0.1

item.scenery=New scenery
item\ent=CopyEntity(palmtree)
PositionEntity item\ent,vpx#,TerrainY(terr,vpx#,0,vpz#),vpz#
item\collon=0

EndIf

EndIf

	
	
EndIf

If (index Mod 4)=3 Then dorotex(1)

Next


CloseFile sev
EndIf


rodist#=1
tunon=0
roady#=0

For tu=1 To (totverts/4)

findverts(tu-1)

.build_tunnel

;tunnels

tse=tunneldat(tracknum,tu)
If tse>0 Then tunon=1-tunon

tunhere(tu)=tunon

If tse>0 And tunon=1

tun.rtunnel=New rtunnel

tun\ent=CreateMesh()
tunsurf=CreateSurface(tun\ent)
EntityTexture tun\ent,tuntex(tse)
EntityType tun\ent,TUNSTRUCT


EndIf


If tunon=1

For ff=1 To 2
;inner (1,2) and outer (0,3)
For gg=1 To tunsegs+1

If gg=1 Then AddVertex tunsurf,vx#(2-ff),vy#(2-ff),vz#(2-ff),(gg Mod 2),roady#
If gg=tunsegs+1 Then AddVertex tunsurf,vx#(ff+1),vy#(ff+1),vz#(ff+1),(gg Mod 2),roady#

If gg>1 And gg<tunsegs+1
vang#=gg*200/tunsegs-100-200/tunsegs

magnit#=((vect#(1,ff+1))^2+(vect#(3,ff+1))^2)^0.5
magnit#=magnit#+5

AddVertex tunsurf,vect#(1,1)+vect#(1,ff+1)*Sin(vang#),vect#(2,1)+magnit#*Cos(vang#),vect#(3,1)+vect#(3,ff+1)*Sin(vang#),(gg Mod 2),roady#

EndIf


tcount=CountVertices(tunsurf)

If gg>1 And tcount>=(tunsegs+2)*2
If ff=1 Then trido=2 Else trido=0
newtri(tunsurf,tcount,(tunsegs+1)*2+2,2,(tunsegs+1)*2+1,trido,1)
newtri(tunsurf,tcount,(tunsegs+1)*2+1,2,1,trido,1)
EndIf

Next
Next


EndIf



If tse>0 And tcount>=(tunsegs+1)*2
;add start and end tris

tcount=CountVertices(tunsurf)

If tunon=1 Then trido=0 Else trido=2

For rr=1 To tunsegs
newtri(tunsurf,tcount,(tunsegs+1)*2+1-rr,tunsegs+2-rr,(tunsegs+1)*2-rr,trido,1)
newtri(tunsurf,tcount,(tunsegs+1)*2-rr,tunsegs+2-rr,tunsegs+1-rr,trido,1)
Next

EndIf

dorotex(2)

;walls
If (tu Mod 2)=0 Then bartex=0 Else bartex=1

;add to left wall
verx#=vx#(1)+(vx#(2)-vx#(1))*(0.5-rodist#)
verz#=vz#(1)+(vz#(2)-vz#(1))*(0.5-rodist#)
very#=TerrainY(terr,verx#,0,verz#)

AddVertex w1surf,verx#,very#,verz#,bartex,0
AddVertex w1surf,verx#,very#+5,verz#,bartex,1

If tu>1
wcount=CountVertices(w1surf)
newtri(w1surf,wcount,4,2,3,1)
newtri(w1surf,wcount,3,2,1,1)
EndIf


;add to right wall
verx#=vx#(1)+(vx#(2)-vx#(1))*(0.5+rodist#)
verz#=vz#(1)+(vz#(2)-vz#(1))*(0.5+rodist#)
very#=TerrainY(terr,verx#,0,verz#)

AddVertex w2surf,verx#,very#,verz#,bartex,0
AddVertex w2surf,verx#,very#+5,verz#,bartex,1

If tu>1
wcount=CountVertices(w2surf)
newtri(w2surf,wcount,4,2,3,1)
newtri(w2surf,wcount,3,2,1,1)
EndIf

Next




.racing_line
tu=0:whole=0

Repeat

If KeyHit(1) Then End

tu=tu+1
If tu>(totverts/4) Then tu=1:whole=1

;calculate racing line at this point
findverts(tu)		
findverts(tu+30,road_angle#)
ahead#=-road_angle#

findverts(tu)		
findverts(tu-30,road_angle#)
behind#=road_angle#

combine#=ahead#+behind# ;magnitude of corner

vca#=Sgn(ahead#)*Sgn(behind#)

If vca#=-1 Then combine#=ahead#

;used for middle of corner

;combine>0, roadline++
;combine<0, roadline--

 
contrast#=0

If Abs(ahead#)>50 And Abs(behind#)<15 Then contrast#=ahead#
If Abs(behind#)>30 And Abs(ahead#)<30 Then contrast#=behind#


If contrast#<>0 Then combine#=0

;combine#=0:contrast#=0

If tunhere(tu)=1 Then combine#=combine#/2:contrast#=contrast#/2

roadtend#=0.5+(combine#/100)-(contrast#/100)


If tu+whole=1 Then roadline#=roadtend#
If tu+whole>1

max#=0.03
;max#=0.4

roadup#=(roadtend#-roadline#)*max#*2
If roadup#>max# Then roadup#=max#
If roadup#<-max# Then roadup#=-max#
roadline#=roadline#+roadup#
EndIf

If roadline#<0.05 Then roadline#=0.05
If roadline#>0.95 Then roadline#=0.95

race_line#(tu)=roadline#

slide#=Abs(race_line#(tu)-race_line#(tu+1))

canend=0
If whole=1 And slide#<0.01 Then canend=1

Until canend=1

tut=tu


linelength#=0


For tu=1 To (totverts/4)

findverts(tu-1)

;add to racing line
roadline#=race_line#(tu)

point(roadline#-0.02)
verx1#=posx#:very1#=posy#+0.2
verz1#=posz#

point(roadline#+0.02)
verx2#=posx#:very2#=posy#+0.2
verz2#=posz#

nex#=(verx1#+verx2#)/2
ney#=(very1#+very2#)/2
nez#=(verz1#+verz2#)/2

If tu>1

linelength#=linelength#+((nex#-oex#)^2+(ney#-oey#)^2+(nez#-oez#)^2)^0.5

EndIf

oex#=(verx1#+verx2#)/2
oey#=(very1#+very2#)/2
oez#=(verz1#+verz2#)/2

AddVertex racelinesurf,verx1#,very1#,verz1#
AddVertex racelinesurf,verx2#,very2#,verz2#

If tu>1
rcount=CountVertices(racelinesurf)
newtri(racelinesurf,rcount,4,2,3,1)
newtri(racelinesurf,rcount,3,2,1,1)

EndIf



Next

length#=Int(linelength#/1.6)

linelength#=length#/1000



For item.scenery = Each scenery
If MeshesIntersect(item\ent,road)

;FreeEntity item\ent
;Delete item

EndIf
Next



End Function



Function newtri(surf,total,one,two,three,backon,dontflip=0)
If mirror=1 And dontflip=0 Then backon=2-backon
If backon<=1 Then AddTriangle(surf,total-one,total-two,total-three)
If backon>=1 Then AddTriangle(surf,total-one,total-three,total-two)
End Function



Function followroad(gcar.vehic,level)

	
	respot=0
	exdist#=50	
	nextpiece=0
	lookmode=1
	overstart=0
	
Repeat
	
	;If KeyHit(1) Then End
	
	gcar\onpiece=gcar\onpiece+lookmode*(1-reverse*2)
	
	out=findverts(gcar\onpiece)
	
	If gcar\onpiece<>out Then gcar\onpiece=out:overstart=overstart+lookmode ;gone over start line either way
		
	If gcar\num=playercar Then PositionEntity roadpivot,(vx#(1)+vx#(2))/2,(vy#(1)+vy#(2))/2,(vz#(1)+vz#(2))/2
		
	dvx#=(vx#(1)+vx#(2))/2-EntityX(gcar\car)
	dvy#=(vy#(1)+vy#(2))/2-EntityY(gcar\car)
	dvz#=(vz#(1)+vz#(2))/2-EntityZ(gcar\car)
	
	oldexdist#=exdist#
	
	exdist#=(dvx#^2+dvz#^2+0^2)^0.5
	
	resetcar=0
	
	If exdist#>50
	If MilliSecs()-gcar\offroad<2000 Then gcar\offroad=MilliSecs()-2000
	EndIf
			
	roadang#=calc_ang#(vx#(1)-vx#(2),vz#(1)-vz#(2),-90)
	
	theta#=calc_ang#(-dvx#,-dvz#,roadang#)
	If gcar\num=playercar Then gcar\notice#=theta#
	
	;abs(theta#)>=90 ;means car is AHEAD of this road line
	;abs(theta#)<90 ;means car is BEHIND this road line
	
	frontback=-1
	If Abs(theta#)>=90 Then frontback=1
	If reverse=1 Then frontback=-frontback
	
	If frontback*lookmode=1 Then nextpiece=1
	
	If frontback=-1 And nextpiece=0
	If lookmode=1 Then lookmode=-1 ;for car going wrong way
	EndIf
			
Until frontback*lookmode=-1
	


nextlap=0

.lapping

If countnum<=0

If overstart=-1 Then gcar\unlapped=gcar\unlapped+1
If overstart=1 Then nextlap=1 ;then car has completed a lap

EndIf

If nextlap=1 And gcar\unlapped=0	
	show=1
	If allcpu=1 And numcars>1 Then show=0
	
	
	If gcar\num=playercar And show=1 And sepia=0
	
		
	
		If gcar\lap=tracklaps(tracknum) Then newview=9:allcpu=1:endrace=1
	
		timed=MilliSecs()-laptimer
		
		If gcar\lap>0
		
		lastlap=timed		
		
		If timed<laprecord(tracknum,reverse+1) Or laprecord(tracknum,reverse+1)=0
			bestlap=gcar\lap:laprecord(tracknum,reverse+1)=timed
		EndIf
		
		
		If framenum<ghost_frames(tracknum,mirror*2+reverse+1) Or ghost_frames(tracknum,mirror*2+reverse+1)=0
			
			
			cc=framenum/ghostween
			
			ghost_filesize(tracknum,mirror*2+reverse+1)=cc
			
			ghost_frames(tracknum,mirror*2+reverse+1)=framenum
			
			
			For zb=0 To cc
			For zc=1 To 6
			zbb=zb*ghostween+1
			If zb=cc Then zbb=framenum
			ghost(tracknum,mirror*2+reverse+1,zb,zc)=pre_ghost(zbb,zc)
			Next
			Next
			
			For hh=1 To 20
			gchecktime(tracknum,mirror*2+reverse+1,hh)=pchecktime(hh)
			Next			
			
			
		EndIf
		
					
		
		EndIf
		
		If gcar\lap<=tracklaps(tracknum)
		laptime$(gcar\lap)=clocker$(timed)
		If gcar\lap>0 And game_type<4 Then updatebest(timed,1)		
		EndIf
		
		laptimer=MilliSecs()
		If gcar\lap=0 Then racetimer=MilliSecs()
	
		framenum=1
		
	
	EndIf
	gcar\onpiece=out
	
	
	If game_type<>3 Or gcar\lap=0
	
	If gcar\lap=tracklaps(tracknum) And gcar\num=playercar
	
	rtimed=MilliSecs()-racetimer
	updatebest(rtimed,2)
	
	EndIf
		
	If gcar\lap<=tracklaps(tracknum) Then gcar\lap=gcar\lap+1
	
	
	EndIf
	
	EndIf		


If nextlap=1 And gcar\unlapped>0 Then gcar\unlapped=gcar\unlapped-1


;end of lap stuff


	
	
	
	
	
	gcar\exdist#=Abs(exdist#) ;used for determining race position accurately
	
	
	If nextpiece=1 Or Abs(gcar\fromcent#)<trackwid*0.8 Then gcar\movedon=MilliSecs()
	
	If MilliSecs()-gcar\sunk>1000 Then resetcar=1
	If MilliSecs()-gcar\offroad>3000 Then resetcar=1
	
	If MilliSecs()-gcar\movedon>3000 Then resetcar=1
	
	If gcar\num=4 Then uuu#=MilliSecs()-gcar\movedon
	
	If gcar\lap>0 And carvel#<=0.05
	If Abs(gcar\fromcent#)>trackwid+2 Then resetcar=1
	EndIf
	
	If MilliSecs()-gcar\recover>1000 And racestart=1
	RotateEntity gcar\car,0,0,0
	resetcar=1	
	EndIf
	
	If resetcar=1	
	cartoroad(gcar.vehic)
	respot=1
	level=2		
	EndIf
	
	If countnum>-1 ;Or resetcar=1;race not yet started
	gcar\recover=MilliSecs()
	gcar\movedon=MilliSecs()
	gcar\offroad=MilliSecs()
	gcar\sunk=MilliSecs()
	resetcar=0
	EndIf
	
	
	
		
	;work out left/right position on road
	cmag#=(dvx#^2+dvz#^2)^0.5	
	vxd#=vx#(1)-vx#(2)
	vzd#=vz#(1)-vz#(2)
	bmag#=(vxd#^2+vzd#^2)^0.5
	
	bdotc#=dvx#*vxd#+dvz#*vzd#
	
	costheta#=bdotc#/bmag#/cmag#	
	If cmag#=0 Then costheta#=0
		
	gcar\fromcent#=cmag#*costheta#*(1-reverse*2)
	
	
	;yup#=(vy#(1)+vy#(2))/2-EntityY(gcar\car)

	
	
.lookon
	;aim for road piece directly in front, or for one slightly
	;further off (used if car is going to be airborne)
		
	outlook=0
	
	

	
	;offline#=0.5+gcar\fromcent#/30-race_line#(gcar\onpiece)
	
		
	If tracknum=1 Then initlook=5
	If tracknum>1 Then initlook=10 ;change this later
	
	d_ang#=get_angle#(gcar.vehic,initlook,level)
	;get_angle calls findverts so we have their positions
	
	;retain use of d_ang#(lhead=10) here
	If Abs(d_ang#)>5
	If tunhere(get(gcar\onpiece,-5))=1 And tunhere(get(gcar\onpiece,10))=1
	
	initlook=5
	
	EndIf
	EndIf
	
	
	
	If level=2 Then initlook=2
	

	For lookon=initlook To 20
	
	findverts(gcar\onpiece+lookon*(1-reverse*2))
	dvy#=(vy#(1)+vy#(2))/2-EntityY(gcar\car)	
	
	dvyy#=dvy#
	If dvyy#>0 Then dvyy#=0

	;If Abs(gcar\fromcent#)<5 Then act#=0.3 Else act#=0.5
	act#=(gcar\speed)^2

	leap#=(gcar\speed)^2*(Abs(dvyy#))*act#
	
	outlook=lookon
	
	If leap#<lookon Then lookon=20
		
	Next
	
	
	d_ang#=get_angle#(gcar.vehic,outlook,level)
	
	
		
	;gcar\onpiece=gcar\onpiece-1	
		
	slowdown=0:watch=0
	If gcar\lap=0 Then watch=1
	If gcar\lap=1 And gcar\onpiece<80 Then watch=1
	If tracknum=1 Then watch=1
	;watch=1, cars stick to their side of road

	
	gcar\accel#=.005


If gcar\num<>playercar Or allcpu=1 Or racestart=0 Or respot=1
	
	
	dfact#=1+(ochoice(1)-1)*0.1

	gcar\accel#=enemybase#(tracknum,1)*dfact#
	
	If level=1
		
	gcar\wturn#=gcar\wturn#+d_ang#/2
	
	If watch=1 And numcars>1
	;If (gcar\num Mod 2)=1 And gcar\fromcent#>-3 Then d_ang#=d_ang#+10
	;If (gcar\num Mod 2)=0 And gcar\fromcent#<3 Then d_ang#=d_ang#-10
	EndIf
		
	EndIf
	
	d_ang#=-d_ang#
	
	If level=2 Then TurnEntity gcar\car,0,-d_ang#,0

	
	If gcar\wturn#>30 Then gcar\wturn#=30
	If gcar\wturn#<-30 Then gcar\wturn#=-30
	
	co_left=0:co_right=0:co_rev=0:co_for=0
	
	agap#=numcars*1000
	
	;gcar\accel#=.006-(gcar\num)/agap#
	
	If gcar\num>0 Then cpustuff(gcar.vehic)
	
			
EndIf

End Function




Function calc_ang#(rya#,ryb#,minus#)
	
	ryc#=ATan#(rya#/ryb#)
	If ryb#<0 Then ryc#=180+ryc#
	ryc#=-ryc#

	res#=ryc#-minus#
	
	res#=sortangle#(res#)	
		
	Return(res#)
	
End Function

Function sortangle#(aa#)

	If aa#<0 Then aa#=360-((-aa#) Mod 360)
	aa#=aa# Mod 360
	If aa#>180 Then aa#=aa#-360
	
	Return(aa#)

End Function



Function findverts(here,cyaw#=0)

;find road co-ords based on road position 'here'
;here*4 because each road section has 4 vertices

tverts=CountVertices(surface)

If here*4+1>tverts Then here=here+1-tverts/4
If here*4+1<0 Then here=here+tverts/4-1

	For pp=0 To 3
	
	rr=pp
	If mirror=1 Then rr=3-pp
	
	vx#(pp)=VertexX(surface,here*4+rr)
	vy#(pp)=VertexY(surface,here*4+rr)
	vz#(pp)=VertexZ(surface,here*4+rr)
	Next
	
	road_angle#=calc_ang#(vx#(2)-vx#(1),vz#(2)-vz#(1),cyaw#+reverse*180)
	
Return(here)
	
End Function


Function get(at,dx)
here=at+dx*(1-reverse*2)

tverts=CountVertices(surface)

If here*4+1>tverts Then here=here+1-tverts/4
If here*4+1<0 Then here=here+tverts/4-1

Return(here)

End Function



Function clocker$(acd)

;acd = millisecs()
;the function turns this into clock form

If acd=0 Then Return("__'__''___")

sw=acd/1000
sx$=Str$(acd Mod 1000)
sy$=Str$(sw/60)
sz$=Str$(sw Mod 60)
While Len(sy$)<2
	sy$="0"+sy$
Wend
While Len(sz$)<2
	sz$="0"+sz$
Wend
While Len(sx$)<3
	sx$="0"+sx$
Wend

trr$=sy$+"'"+sz$+"''"+sx$
Return(trr$)

End Function


Function debugtext(gcar.vehic)

	For mv=1 To 4
	If mv=1 Then ion=co_left
	If mv=2 Then ion=co_right
	If mv=3 Then ion=co_for
	If mv=4 Then ion=co_rev
	
	Color 0,127*(1+ion),0
	Rect mv*30,5,20,20
		
	Next
	
	Color 127*(1+slowdown),0,0
	Rect 150,5,20,20
	
	

Color 255,255,255

;Text 0,100,dvy#

Text 0,200,scount+" of "+stotal+" trees are active"
Text 0,220,"no. impacts = "+impacts

Text 0,240,road_angle2#
Text 0,260,gcar\exdist#

Text 0,280,"Average Speed = "+sumofspeed/countspeed

gt$="car positons   "
For ii.vehic=Each vehic
gt$=gt$+"-"+Str$(ii\place)
Next

Text 0,300,gt$
	
End Function

Function savescreenshot()   
iFileNumber% = 0  
Repeat  iFileNumber = iFileNumber + 1  
sFileName$ = "motor_shot" + String$("0", 3 - Len(Str$(iFileNumber))) + iFileNumber + ".jpg"  
Until Not(FileType(sFileName))   
SaveBuffer FrontBuffer(), sFileName   
End Function


Function makeplane(extent,detail,texture,ypos#,alpha#)

;could just use createplane for infinite plane
;but this version allows sections to be missed out


stretch=extent/detail

For ii=0 To detail
For ij=0 To detail
AddVertex psurf,ii*stretch,0,ij*stretch,(ii Mod 2),(ij Mod 2)

If ii>0 And ij>0
xp=ii*stretch;-extent/2-stretch/2
yp=ij*stretch;-extent/2-stretch/2

see=0

tery(ii,ij)=TerrainY(terr,xp,10,yp)

If tery(ii,ij)=0 Or tery(ii-1,ij)=0 Then see=1
If tery(ii,ij-1)=0 Or tery(ii-1,ij-1)=0 Then see=1
;see=1

If see=1

cc=CountVertices(psurf)
bl=cc-detail-3
br=cc-detail-2
tl=cc-2
tr=cc-1
AddTriangle psurf,bl,br,tl
AddTriangle psurf,br,tr,tl

EndIf
EndIf

Next
Next

PositionEntity plane,-extent/2,ypos#,-extent/2
EntityAlpha plane,alpha#

End Function



Function newrect(surf,xat#,yat#,zat#,xdx#,ydy#,lx#,ty#,rx#,by#,scape,ang#)

;newrect(surface,x,y,z,xd,yd,l_uv,t_uv,r_uv,b_uv,type,angle)


;a rect not attached to other rects
;ang# is used to vary the angle of tree segments

If scape=1 Then uux#=lx#:vvx#=rx#:uuy#=by#:vvy#=ty#
If scape=2 Then uux#=rx#:vvx#=lx#:uuy#=ty#:vvy#=by#

xtx#=xdx#*Cos(ang#)
ztz#=xdx#*Sin(ang#)

AddVertex surf,xat#-xtx#,yat#-ydy#,zat#-ztz#,lx#,by#
AddVertex surf,xat#+xtx#,yat#-ydy#,zat#+ztz#,vvx#,uuy#
AddVertex surf,xat#-xtx#,yat#+ydy#,zat#-ztz#,uux#,vvy#
AddVertex surf,xat#+xtx#,yat#+ydy#,zat#+ztz#,rx#,ty#
total=CountVertices(surf)
newtri(surf,total,1,3,2,1)
newtri(surf,total,2,3,4,1)

End Function




Function keepaway(gcar.vehic)

;simple car collisions system
;stops them from overlapping each other
;views each car as 3 spheres

For icar.vehic = Each vehic

If gcar\num<icar\num And gcar\num>0

If EntityDistance(gcar\car,icar\car)<10

For gpiv=1 To 3
gx#=EntityX(gcar\pivot[gpiv],True)
gy#=EntityY(gcar\pivot[gpiv],True)
gz#=EntityZ(gcar\pivot[gpiv],True)

For ipiv=1 To 3
ix#=EntityX(icar\pivot[ipiv],True)
iy#=EntityY(icar\pivot[ipiv],True)
iz#=EntityZ(icar\pivot[ipiv],True)

dist#=((ix#-gx#)^2+(iy#-gy#)^2+(iz#-gz#)^2)^0.5

If dist#<3
xacc#=(ix#-gx#)*0.1/dist#
yacc#=(iy#-gy#)*0.1/dist#
zacc#=(iz#-gz#)*0.1/dist#

gcar\transx#=gcar\transx#-xacc#
gcar\transy#=gcar\transy#-yacc#
gcar\transz#=gcar\transz#-zacc#

icar\transx#=icar\transx#+xacc#
icar\transy#=icar\transy#+yacc#
icar\transz#=icar\transz#+zacc#

If gpiv>=ipiv Then gup#=0.05:iup#=0.1
If ipiv>gpiv Then gup#=0.1:iup#=0.05

gup#=gup#*0.5

gcar\speed=gcar\speed+gup#*(gpiv-ipiv)
icar\speed=icar\speed+iup#*(ipiv-gpiv)
impacts=impacts+1

EndIf


Next
Next


EndIf
EndIf

Next

End Function


Function MakeSkyBox( file$,format$ )


	m=CreateMesh()
	;front face
	b=LoadBrush( file$+"_FT."+format$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;right face
	b=LoadBrush( file$+"_LF."+format$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( file$+"_BK."+format$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( file$+"_RT."+format$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( file$+"_UP."+format$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b

	ScaleMesh m,600,600,600
	FlipMesh m
	;EntityFX m,8
	EntityOrder m,1
	Return m
	
	
End Function

Function docollisions()

Collisions BODY,SCENE,2,3
Collisions BODY,TARMAC,2,3
Collisions BODY,STRUCT,2,3
Collisions BODY,BOXSTRUCT,3,3
Collisions BODY,TUNSTRUCT,2,3

Collisions BODYROAD,TARMAC,2,3

Collisions WHEEL,SCENE,2,3
Collisions WHEEL,TARMAC,2,3

Collisions WHEELROAD,TARMAC,2,3

End Function



Function cartoroad(gcar.vehic)

	findverts(gcar\onpiece)

	If gcar\num=playercar Then snapview=1
	
	PositionEntity gcar\car,(vx#(1)+vx#(2))/2,(vy#(1)+vy#(2))/2+5,(vz#(1)+vz#(2))/2
	ResetEntity gcar\car
	
	For dd=1 To 4
	ResetEntity gcar\wheels[dd]
	Next
	
	gcar\lockout=1	
	gcar\speed=0
	gcar\recover=MilliSecs()
	
		
End Function


Function screendata(gcar.vehic)


Color 0,0,0
	Rect 530,0,110,40
	Rect 530,50,110,40
	Rect 530,100,110,40
	
	Color 255,255,255
	SetFont font2
	velo$=Str$(Abs(Int(gcar\speed*convert)))
	
	Text 580-StringWidth(velo$),55,velo$
	Text 590,55,"kph"
	
	If gcar\lap<=tracklaps(tracknum) Then Text 540,5,"Lap "+gcar\lap+"/"+tracklaps(tracknum)
	If gcar\lap>tracklaps(tracknum)
	
	Text 540,5,"Finish"
	
	If game_type<4 And playercar=1
	message$="RACE TIME = "+clocker$(rtimed)	
	Text 320-StringWidth(message$)/2,50,message$	
	
	message$="YOU PLACED   "+gcar\place+endnumber$(gcar\place)
	If numcars>=4 Then Text 320-StringWidth(message$)/2,90,message$
	
	EndIf
	
	
	EndIf
	
	If allcpu=1
	
	Text 0,300,opponent$(playercar)
	Text 0,330,viewname$(newview)
		
	EndIf
	
	
	Text 540,105,"P  "+gcar\place+"/"+numcars	
	
	If game_type<4 Or numcars=1
	;don't do these if in watch mode (mode 4)
	
.watch_mode_stuff
	
	best_time$=clocker$(records(tracknum,mirror*2+reverse+1,1))
	
	
	dotext("Best Lap =",320,440,255,0,0,-2,0)
	dotext(best_time$,480,440,255,0,0,-2,0)
	
	If game_type=2 Or game_type=3
	your_best$=clocker$(laprecord(tracknum,reverse+1))
	dotext("Your Best =",320,410,0,0,255,-2,0)
	dotext(your_best$,480,410,0,0,255,-2,0)
	
	dotext("Last Lap =",320,380,0,255,0,-2,0)
	dotext(clocker$(lastlap),480,380,0,255,0,-2,0)
	
	EndIf
	
	If showlagg>0 Then showlagg=showlagg-1
	
	
	
	
	yourplace=gcar\place
	
	SetFont font
	
	For ii=1 To gcar\lap
	
	If ii<=tracklaps(tracknum)
	
	Color 0,0,0
	Rect 3,9+ii*18,15,15
	Rect 23,9+ii*18,60,15
	
	Color 255,255,255
	
	Text 6,9+ii*18,ii
	
	If game_type<>3
	If ii=gcar\lap-1 Then Color 255,255,0
	If ii=bestlap Then Color 255,0,0
	EndIf
	
	If ii=gcar\lap
	
	If pausemenu=0 Then laptime$(ii)=clocker$(MilliSecs()-laptimer)
	If pausemenu=1 Then laptime$(ii)=clocker$(rem_laptimer)
	
	EndIf
	
	Text 26,10+ii*18,laptime$(ii)
	
	EndIf
	
	Next
	
	EndIf
	
	SetFont font
	
	If zoomout#<=0
	
.debug_text
	
	Color 255,255,255
	Text 250,0,"Frames Per Sec = "+tframs
	Text 0,180,"Tris "+TrisRendered()
	Text 0,220,scount+" of "+stotal+" trees are active"

	;For ii=1 To 3
	;Text 0,300+ii*20,odxy#(ii,1)
	;Text 100,300+ii*20,odxy#(ii,2)
	;Next

	;Text 0,200,reverse	
	;draw the map of cars close to you
	;Text 0,200,gcar\fromcent#
	;Text 0,260,road_angle2#	
	;Text 0,240,race_line#(gcar\onpiece)
	;Text 0,200,yup#
	;Text 0,280,gcar\fromcent#
	
	If framtot>0
	Text 0,200,"Toggle "+(fram3*100/framtot)+"%"	
	EndIf
	
	
	Rect 450,5,50,100,False
	
	
	centx#=475:centy#=55
	
	
	Color 255,0,0
	Line centx#,centy#-2,centx#,centy#+2
	
	Color 128,255,128
	
	For icar.vehic = Each vehic
	
	vvx#=EntityX(icar\car)-EntityX(gcar\car)
	vvz#=EntityZ(icar\car)-EntityZ(gcar\car)
	vmag#=(vvx#^2+vvz#^2)^0.5
	vang#=calc_ang#(vvx#,vvz#,carya#)
		
	pxx#=centx#-vmag#*Sin(vang#)
	pyy#=centy#-vmag#*Cos(vang#)
	
	If pxx#>=450 And pxx#<=500 And pyy#>=5 And pyy#<=105
	
	aseen#=EntityYaw(icar\car)-carya#
	Line pxx#-Sin(aseen#)*2,pyy#-Cos(aseen#*2),pxx#+Sin(aseen#)*2,pyy#+Cos(aseen#*2)
	
	EndIf
		
	Next
	
	EndIf
	
End Function


Function maskit(texture,ref)

SetBuffer TextureBuffer(texture)

LockBuffer GraphicsBuffer()

For xx=0 To TextureWidth(texture)-1
For yy=0 To TextureHeight(texture)-1

rst=ReadPixelFast(xx,yy)


;If ref=2 Then rst=rst+16777216

If ref=2 And xx=32 And yy=32 Then rstref=rst


;If xx=0 And yy=0 Then maskit=rst

uu=rst
;If ref=2 Then 
uu=uu+16777216
b=uu Mod 256
uu=uu/256
g=uu Mod 256
uu=uu/256
r=uu Mod 256

If ref=2 And xx=32 And yy=32 Then bbb=b:ggg=g:rrr=r

do_mask=0

If ref=1
If r>g+50 Or r>b+50 Then do_mask=1
EndIf

If ref=2
If r+g+b<100 Then do_mask=1
EndIf

If ref=3 And r+g+b=0 Then do_mask=1

If ref=4 And r>128 Then do_mask=1

;do_mask=1

If do_mask=1
WritePixelFast xx,yy,$00000000
Else
WritePixelFast xx,yy,rst
EndIf

Next
Next


UnlockBuffer GraphicsBuffer()

SetBuffer BackBuffer()

End Function


Function titles()

If menuscreen=1 Then HideEntity coursemap
If menuscreen=2 Then ShowEntity coursemap

prevscreen=0
If KeyHit(1) Then prevscreen=1
If JoyHit(1) Then prevscreen=1
If JoyHit(5) Then prevscreen=1


If prevscreen=1 ;previous menu screen

;option=1:boxpoint=1

If namescreen=1 Or offset#>0
save()
End
EndIf


If offset#<=0 And namescreen<>1 And menuscreen=1 Then namescreen=1

If menuscreen>1 And menuscreen<4 Then menuscreen=1
If menuscreen=4 Then menuscreen=2

EndIf

EntityColor filter,150,64,0
EntityAlpha filter2,0

EntityAlpha filter,alpha#
If alpha#<0.7 Then alpha#=alpha#+0.003


Color 0,0,0
Rect 0,0,25,480
Rect 615,0,25,480

For nn=1 To 7
DrawImage sidebar,20,(nn-3)*96-twoset#
DrawImage sidebar,600,(nn-3)*96-twoset#
Next

rotat=rotat+1
If rotat=73 Then rotat=1

If menuscreen=1

SetFont font3
dotext("STOCKCAR",50-offset#,20,0,0,255,5,0)
dotext("SCRAMBLE",50+offset#,110,0,0,255,5,0)

Color 0,0,0
Oval 195-offset#,200,250,100

dotext("2004",220,200+offset#/2,255,0,0,5,0)

EndIf



If offset#=0

SetFont font2

boxheight=30
topy=320

If namescreen<2

If menuscreen=1 Then dotext(yourname$,220,topy,128,64,0,3,40)
If menuscreen=2 Or menuscreen=4 Then dotext(yourname$,370,10,128,64,0,3,40,StringWidth(yourname$)+80)

EndIf

If namescreen=2
;register a new name


dotext("ENTER YOUR NAME",200,topy,128,64,0,3,10)

cursor$=""
If curson=1 Then cursor$="_"

dotext(newname$+cursor$,200,topy+30,0,64,128,3,10,160)

value=GetKey()

If value=4 Or value=8
value=0
If Len(newname$)>0 Then newname$=Left$(newname$,Len(newname$)-1)
EndIf

If value=13

value=0

validname=1

For kk=1 To 5
If newname$=time_name$(kk) Then validname=0
Next

For ll.name=Each name
If newname$=ll\player$ Then validname=0
Next


If validname=1
;accept the new name

namescreen=0
FlushKeys()

hhh.name=New name
hhh\player$=newname$

yourname$=newname$

EndIf

If validname=0
;reject the new name

newname$=""
EndIf

EndIf

If value>0 And StringWidth(newname$)<130
;If value>96 And value<123 Then value=value-32
newname$=newname$+Chr$(value)
EndIf



EndIf






If namescreen=1
;select new player or one already registered

yourname$="NEW PLAYER"

namecount=0
For who.name = Each name
namecount=namecount+1
Next

boxheight=30*(namecount+1)
topy=320
deletename=0
If KeyHit(14) Then deletename=1
If KeyHit(211) Then deletename=1

scount=0

For who.name = Each name
scount=scount+1


If chosen=scount+1
yourname$=who\player$
namescreen=0
EndIf

dotext(who\player$,220,topy+scount*30,0,128,0,3,40)


If option=scount+1 And deletename=1
Delete who
EndIf

Next


menupointer(410,topy-25,30,scount+1,scount+1)

If chosen=1
namescreen=2
newname$=""
FlushKeys()
EndIf


EndIf



If namescreen=0
;name chosen - ready for next menu

If menuscreen=1

dotext(mainmenu$(option+1-boxpoint),220,380,0,0,128,3,40)
dotext(mainmenu$(option+2-boxpoint),220,420,0,0,128,3,40)

menupointer(420,345,40,5,2)

If chosen>0 And chosen<5
menuscreen=2
gamechoice=chosen
EndIf

If chosen=5
;go to options
menuscreen=3
EndIf


EndIf


If menuscreen=3 ; options

.options_menu

For ss=1 To opsize
dotext(optname$(ss),60,ss*40-20,128,0,0,3,10,200)
dotext(opton$(ss,ochoice(ss)),400,ss*40-20,128,128,128,3,10,150)
Next

dotext("OK",60,opsize*40+20,128,0,0,3,10,200)

menupointer(310,-15,40,opsize+1,opsize+1)

If chosen>0 And chosen<=opsize
ochoice(chosen)=ochoice(chosen)+1
If ochoice(chosen)>optsize(chosen) Then ochoice(chosen)=1
EndIf

If chosen=opsize+1 Then menuscreen=1

EndIf


.tracks_menu

If menuscreen=2 Or menuscreen=4;select a track

If KeyHit(46)
;Press C to Clear Track Records
For uu=1 To 8
For vv=1 To 5
recname$(tracknum,uu,vv)=time_name$(vv)
records(tracknum,uu,vv)=defaults(tracknum,uu,vv)
Next
Next

save()

EndIf

dotext(trackname$(tracknum),60,10,0,128,0,3,10)

dotext(mainmenu$(gamechoice),60,40,0,128,0,3,10,200)

dotext("TRACK LENGTH",60,300,0,128,128,3,10,220)

metres#=totvert(tracknum)*1.25

dotext(Str$(metres#/1000)+" km",60,350,0,128,128,3,10,150)


For si=1 To 2
If si=1 Then dotext("BEST LAPS",320,50,0,128,0,3,20)
If si=2 Then dotext("BEST RACES",320,250,0,128,0,3,20)

If si=2 Then dotext("("+tracklaps(tracknum)+" LAPS)",490,250,0,128,128,3,0)

filepart=si*4+nchoice-4

For sk=1 To 5

rr=160:gg=160:bb=160
If recname$(tracknum,filepart,sk)=yourname$ Then bb=0

dotext(recname$(tracknum,filepart,sk),320,60+sk*30+(si-1)*200,rr,gg,bb,3,20)
dotext(clocker$(records(tracknum,filepart,sk)),470,60+sk*30+(si-1)*200,rr,gg,bb,3,0)

Next
Next

dotext(normal$(nchoice),60,400,0,0,255,3,10,200)



If menuscreen=2

menupointer(310,15,0,racetracks,1)

If option<>tracknum And chosen=0
tracknum=option
EntityTexture coursemap,maptex(tracknum)
ScaleEntity coursemap,t_size#(tracknum,1)/300,t_size#(tracknum,2)/300,1

;createmap("tracks/trackdata"+tracknum+".dat")
EndIf

If chosen>0 Then menuscreen=4

EndIf


If menuscreen=4

menupointer(220,405,0,4,1)


nchoice=option

If chosen=0
mirror=1-(option Mod 2)
reverse=(option-1)/2
EndIf

If chosen>0
sepia=0
setup_start(gamechoice)
ingame=1
EndIf

EndIf

If t_mirror(tracknum)<>mirror And chosen=0
t_mirror(tracknum)=mirror
;createmap("tracks/trackdata"+tracknum+".dat")
;ScaleEntity coursemap,-1,1,-1
EndIf

.draw_map_on_menu

zz#=zoom#(tracknum)
PositionEntity coursemap,-1.2/zz#,0.5/zz#,2.5/zz#
;If reverse=1 Then PositionEntity coursemap,-1.3,-0.5,1
EntityOrder coursemap,-3
ShowEntity coursemap
RotateEntity coursemap,0,mirror*180,reverse*180


EndIf

EndIf


;ends offset#<=0 if statement
EndIf


If offset#>0
offset#=offset#-4
Else
If offset#<0 Then offset#=offset#+6.5
EndIf

twoset#=twoset#-3
If twoset#<=-120 Then twoset#=twoset#+96

If MilliSecs()-waiting>10000
sepia=0
tracknum=Int(Rnd#(racetracks)+0.5)
EntityTexture coursemap,maptex(tracknum)
ScaleEntity coursemap,t_size#(tracknum,1)/300,t_size#(tracknum,2)/300,1
mirror=Int(Rnd#(2)-0.5)
reverse=Int(Rnd#(2)-0.5)
setup_start(4)
ingame=1
EndIf


End Function


Function setup_start(cmode)


If cmode=1 Then numcars=12
If cmode=2 Then numcars=1
If cmode=3 Then numcars=1
If cmode=4 Then numcars=12 ;set to 1 for lap speed testing

game_type=cmode

If tracknum=loadedtrack And gateverse<>reverse
TurnEntity stgate,0,180,0
gateverse=reverse
EndIf

;If tracknum<>loadedtrack Or mirror<>cmirror Then 
new_scene()

reset()


End Function


Function twodeedata()


;draw car pointers on course map
	If zoomout#>0
	usechars(trackname$(tracknum),0,0,2)
	usechars(mainmenu$(game_type),0,40,1)	
	usechars(normal$(mirror*2+reverse+1),0,60,1)
	usechars(opton$(1,ochoice(1)),0,80,1)	
	EndIf

	ocar.vehic=Object.vehic(yourcar)

	findverts(ocar\onpiece,-90) ;finds road_angle# for map rotation
	
	
	caryaw#=EntityYaw(ocar\car)
		
		
	dbx=odxy#(tracknum,1)*4
	dby=-odxy#(tracknum,2)*4
	If mirror=1 Then dbx=-dbx-m_offset#(tracknum)
	
		
	youx#=(EntityX(ocar\car)+dbx)
	youy#=(EntityZ(ocar\car)+dby)
	
	
	gg#=EntityRoll(coursemap)
	If mirror=1 Then gg#=360-gg#
	
	mapchange#=sortangle#(-road_angle#-gg#)

		
	mapangle#=gg#+mapchange#*0.05
	
	If mirror=0 Then RotateEntity coursemap,0,mirror*180,mapangle#
	If mirror=1 Then RotateEntity coursemap,0,mirror*180,360-mapangle#
	
	youang#=calc_ang#(youx#,youy#,0)+90
	
	yousize#=((youx#^2+youy#^2)^0.5)
	
	youmx#=yousize#*Cos(mapangle#+youang#)
	youmy#=yousize#*Sin(mapangle#+youang#)
	
	zz#=zoom#(tracknum)
	mpx#=(mposx#/zz#-youmx#/640)
	mpy#=(mposy#/zz#-youmy#/640)
	mpz#=mposz#/zz#
	mapsize#=640/mpz#
	
	z1#=zoomout#/25
	z2#=1-z1#
	
	PositionEntity coursemap,-0.7*z1#+mpx#*z2#,0.3*z1#+mpy#*z2#,2*z1#+mpz#*z2#
	
	ovrad#=mapsize#*0.02
	
	If numcars>=6
	Color 0,0,0
	Rect 540,210,95,130
	EndIf

	For gcar.vehic = Each vehic
	
	SetFont font
	
	If numcars>=6 And gcar\place<=6	
	Color 128,128,255
	Text 550,200+(gcar\place)*20,"("+gcar\place+") "+opponent$(gcar\num)		
	EndIf
	
	
	If zoomout#<=0 And EntityDistance(camera,gcar\car)<100 And ochoice(2)=1
	
	If gcar\num<>playercar Or endrace=1
	
	
	tpieces=CountVertices(surface)/4
	
	compare=(gcar\lap-ocar\lap)*tpieces+(gcar\onpiece-ocar\onpiece)*(1-reverse*2)
	
	Color 255,255,255
	If compare>tpieces/2 Then Color 255,0,0
	If compare<-tpieces/2 Then Color 0,255,0
	
	CameraProject camera,EntityX(gcar\car),EntityY(gcar\car),EntityZ(gcar\car)	
	Text ProjectedX()-StringWidth(opponent$(gcar\num))/2,ProjectedY()-30,opponent$(gcar\num)
	
	EndIf
	EndIf
	
	If gcar\place=1
	leader=Handle(gcar)
	lcar.vehic=Object.vehic(leader)
	EndIf
	
		
	If gcar\num<>playercar And zoomout#<=0
		
	tomap(gcar\car,ocar\car)
	
	If gcar\place=1
	leadx#=mapx#
	leady#=mapy#
	EndIf
		
	dodot(mapx#,mapy#,ovrad#,1)
		
	EndIf
	
		
	If gcar\num=playercar
	
	If seedebug=1 Then debugtext(gcar.vehic)	
	screendata(gcar.vehic)	
	
	EndIf
	
	
	Next
	
	
	
	If zoomout#<=0
	
	
	dodot(mapcentx#,mapcenty#,ovrad#,2) ;player dot	
	
	
	If ocar.vehic<>lcar.vehic
	dodot(leadx#,leady#,ovrad#,3) ;leader dot
	EndIf
	
	If showghost=1
	tomap(ghost_car,ocar\car)
	dodot(mapx#,mapy#,ovrad#,4) ;ghostcar dot
	EndIf

	EndIf
		
	
	If pausemenu=1
	
	reset_timers()
	
	Color 0,0,0
	Rect 200,200,240,100
	
	SetFont font2
	Color 255,200,100
	Text 210,205,"Continue"
	Text 210,235,"Restart"
	Text 210,265,"Exit"
	SetFont font
	
	menupointer(400,180,30,3,3)
	
	If chosen>0
	pausemenu=0
	;reset_timers()
	EndIf
	
	
	If chosen=3 Then backtotitles()
	If chosen=2 Then reset()
	If chosen=1 Then ResumeChannel musc
	
	EndIf
	
	
	If zoomout#<=0 And countnum>=0
	;SetFont font3
	;dotext(Str$(countnum),300,50,64,64,64,5,0)
	;SetFont font
	
	vtime#=MilliSecs()-countdown
	
	
	
	If vtime#>1000 And pausemenu=0
	countdown=MilliSecs()
	countnum=countnum-1
	If countnum=2 Then PlaySound t2
	If countnum=1 Then PlaySound t1
	vtime#=0
	
	If countnum>=0
	update_num()
	EndIf
	
	If countnum=-1 Then HideEntity numsprite
			
	EndIf
	
	PositionEntity numsprite,0,0,4-vtime#/500
	EntityAlpha numsprite,1-vtime#/1000
		
	EndIf
	
	
	
	
	
	findverts(ocar\onpiece,EntityYaw(ocar\car)-90)
	
	HideEntity turnsprite
	HideEntity boundsprite
	
	If MilliSecs()-ocar\offroad>2000 Or EntityY(ocar\car)<=-1
	ShowEntity boundsprite
	ccc#=1+Sin(pulse)*0.2
	PositionEntity boundsprite,0,ccc#,2*ccc#
	pulse=pulse+10
	
	Else
	
	If Abs(road_angle#)>90
	ShowEntity turnsprite
	ccc#=1+Sin(pulse)*0.3	
	PositionEntity turnsprite,0,ccc#,2*ccc#
	pulse=pulse+10
	
	Else
	
	If showlagg>0
	
	If lagg>0 Then ara=255:aga=0:aba=0
	If lagg<=0 Then ara=255:aga=255:aba=0
	If lagg>0 Then note$="+"+clocker$(lagg)
	If lagg<=0 Then note$="-"+clocker$(-lagg)
	SetFont font2
	dotext(note$,320-StringWidth(note$)/2,50,ara,aga,aba,2,0)
	
	EndIf
	
	
	EndIf
	
	
	EndIf
	
	
End Function


Function menupointer(xpoint,ypoint,jump,many,box,wrap=0)

DrawImage pointer,xpoint,ypoint+boxpoint*jump

;Text 300,300,"SELECTED = "+option

chosen=0:ochange=0
uphit=0:uphold=0
downhit=0:downhold=0

If KeyHit(208) Then downhit=1
If KeyHit(200) Then uphit=1
If KeyDown(208) Then downhold=1
If KeyDown(200) Then uphold=1

If JoyHat()=0 Then uphold=1
If JoyHat()=0 And oldhat<>0 Then uphit=1
If JoyHat()=180 Then downhold=1
If JoyHat()=180 And oldhat<>180 Then downhit=1

If JoyYDir()=-1 Then uphold=1
If JoyYDir()=-1 And oldjoy>-1 Then uphit=1
If JoyYDir()=1 Then downhold=1
If JoyYDir()=1 And oldjoy<1 Then downhit=1

If downhit=1 Then ochange=1:holtime=MilliSecs()
If uphit=1 Then ochange=-1:holtime=MilliSecs()

If MilliSecs()-holtime>500
If downhold=1 Then ochange=1:holtime=MilliSecs()-400
If uphold=1 Then ochange=-1:holtime=MilliSecs()-400
EndIf

oldhat=JoyHat()
oldjoy=JoyYDir() 

option=option+ochange
boxpoint=boxpoint+ochange
If ochange<>0 Then waiting=MilliSecs()

oplow=1:ophigh=many:boxlow=1:boxhigh=box
If wrap=1 Then oplow=many:ophigh=1:boxlow=box:boxhigh=1

If option<1 Then option=oplow
If option>many Then option=ophigh
If boxpoint<1 Then boxpoint=boxlow
If boxpoint>box Then boxpoint=boxhigh

If ingame=0 Or pausemenu=1
If KeyHit(28) Then chosen=option
If JoyHit(2) Then chosen=option
If JoyHit(11) Then chosen=option
EndIf

If chosen>0 And menuscreen<>3 Then option=1:boxpoint=1

End Function


Function reset()

musc=0:framtot=0:fram3=0

skycamx#=-100:skycamy#=0
option=1:boxpoint=1
countnum=3:pausemenu=0
racestart=0:endrace=0
zoomout#=25:newview=2
record=0:mapangle#=0
countdown=MilliSecs()
laptimer=MilliSecs()
allcpu=0:lagg=0:showlagg=0
impacts=0
sumofspeed=0
countspeed=1
gateverse=reverse

If sepia=1
allcpu=1:zoomout#=1:newview=5:racestart=0
EndIf

If game_type=4 Then allcpu=1

frameslost=0

;allcpu=1

createcars(0)
HideEntity ghost_car
showghost=0

EntityAlpha filter2,0
For ring.smokering=Each smokering
FreeEntity ring\smoke_ent
Delete ring
Next

ShowEntity coursemap
RotateEntity coursemap,0,0,reverse*180


If game_type=4 Then opponent$(1)="CLARKSON"

If game_type<>4
opponent$(1)=Upper$(yourname$)
EndIf


playercar=1

For gcar.vehic = Each vehic
If gcar\num=playercar Then yourcar=Handle(gcar)
Next

ocar.vehic=Object.vehic(yourcar)
EntityParent target,ocar\carpivot

lastlap=0

End Function

Function pauseit()
	
	pmenu=0
	
	If KeyHit(1)
	If pausemenu=0 Then pmenu=1
	If pausemenu=1 Then backtotitles()		
	EndIf
	
	If pausemenu=0
	If KeyHit(19) Then pmenu=1
	If JoyHit(5) Then pmenu=1
	If JoyHit(11) Then pmenu=1
	EndIf
	
	If pmenu=1 Then pausemenu=1-pausemenu
	
	If pmenu=1 And pausemenu=1
	
	PauseChannel musc
	
	FlushKeys()
	FlushJoy()
	
	
	If ChannelPlaying(startengines)
	StopChannel startengines
	EndIf
	
	For zz=1 To numcars
	ChannelVolume car_engine(zz),0
	Next
	
	rem_laptimer=MilliSecs()-laptimer
	rem_countdown=MilliSecs()-countdown 
	
	For jcar.vehic = Each vehic
	
	jcar\rem_recover=MilliSecs()-jcar\recover
	jcar\rem_offroad=MilliSecs()-jcar\offroad
	jcar\rem_sunk=MilliSecs()-jcar\sunk
	jcar\rem_onscene=MilliSecs()-jcar\onscene
	jcar\rem_movedon=MilliSecs()-jcar\movedon
	
	Next
	
	EndIf
	
	If pmenu=1 And pausemenu=0
	
	ResumeChannel musc
	reset_timers()	
	EndIf

End Function


Function reset_timers()

	laptimer=MilliSecs()-rem_laptimer
	countdown=MilliSecs()-rem_countdown
	
	For jcar.vehic = Each vehic
	
	jcar\recover=MilliSecs()-jcar\rem_recover
	jcar\offroad=MilliSecs()-jcar\rem_offroad
	jcar\sunk=MilliSecs()-jcar\rem_sunk
	jcar\onscene=MilliSecs()-jcar\rem_onscene
	jcar\movedon=MilliSecs()-jcar\rem_movedon
				
	Next

End Function


Function dotext(word$,xpp#,ypp#,red,green,blue,offx,dobox,boxlength=300)

jpp#=xpp#;-StringWidth(word$)/2

If dobox>0
Color 0,0,0
Rect xpp#-dobox,ypp#,boxlength,30

Color 255,255,255
Rect xpp#-dobox,ypp#,boxlength,30,False
EndIf


Color red,green,blue
Text jpp#-offx,ypp#,word$

Color 255-(255-red)/2,255-(255-green)/2,255-(255-blue)/2
Text jpp#,ypp#,word$


End Function


Function carsense(gcar.vehic)


;If watch=1 Then spdiff#=0.02 Else spdiff#=0.04
spdiff#=40
spdiff#=spdiff#*(gcar\speed+0.2)

rfactor#=2

For icar.vehic = Each vehic


compare=1
If icar\num=gcar\num Then compare=0
If icar\onpiece=gcar\onpiece And icar\exdist#>gcar\exdist#-3 Then compare=0

If compare=1

pdiff#=icar\onpiece-gcar\onpiece


If pdiff#>=0 And pdiff#<20

diffs#=gcar\fromcent#-icar\fromcent#

If Abs(diffs#)<4

sfactor#=(gcar\speed+0.1-icar\speed)*spdiff#/pdiff#


If sfactor#>rfactor#

slowdown=1

If pdiff#<20 And Abs(d_ang#)<5


turndir=Sgn(gcar\fromcent#-road_angle2#*0.5)

;If pdiff#<=1
;If gcar\place<icar\place Then turndir=-Sgn(diffs#)
;EndIf

turndir=Sgn(diffs#)
If offline#>2 Then turndir=-1
If offline#<-2 Then turndir=1

;If turndir<0 Then co_left=1:co_right=0
;If turndir>0 Then co_right=1:co_left=0

;If sfactor#>5 Then co_for=0
;If sfactor#>10 Then co_rev=1

rfactor#=sfactor#

EndIf

EndIf

EndIf

EndIf

EndIf

Next


End Function



Function basecar()

newcar=CreateMesh()
newcarsurf=CreateSurface(newcar)

For i=1 To CountVertices(carsurf)
AddVertex(newcarsurf,VertexX(carsurf,i-1),VertexY(carsurf,i-1),VertexZ(carsurf,i-1),VertexU(carsurf,i-1),VertexV(carsurf,i-1),VertexW(carsurf,i-1))
Next

For j=1 To CountTriangles(carsurf)
AddTriangle(newcarsurf,TriangleVertex(carsurf,j-1,0),TriangleVertex(carsurf,j-1,2),TriangleVertex(carsurf,j-1,1))
Next

FlipMesh newcar

FitMesh newcar,-1.5,-1.2,-3,3,2.4,6
EntityBox newcar,-2,-1,-4,4,2,8


EntityShininess newcar,1
EntityType newcar,BODY

;EntityTexture newcar,altcar
EntityFX newcar,1

HideEntity newcar

End Function


Function get_angle#(gcar.vehic,lookahead,level)

	obs=lookahead

	verton=findverts(gcar\onpiece+lookahead*(1-reverse*2))
	
	linepos#=race_line#(verton)
	If gcar\yup#>30 Then linepos#=0.5+(linepos#-0.5)/2
	If level=2 Then linepos#=0.5+(gcar\fromcent#*(1-reverse*2)/30)
	;If reverse=1 Then linepos#=1-linepos#
	
	dvx#=vx#(1)+(vx#(2)-vx#(1))*linepos#-EntityX(gcar\car)
	dvz#=vz#(1)+(vz#(2)-vz#(1))*linepos#-EntityZ(gcar\car)
			
	found#=calc_ang#(dvx#,dvz#,EntityYaw(gcar\car))	

	Return(found#)

End Function

Function dodot(mxx#,myy#,mag#,dotcol)

	Color 0,0,0
	Oval mxx#-mag#,myy#-mag#,mag#*2,mag#*2
	
	If dotcol=1 Then Color 128,128,128
	If dotcol=2 Then Color 255,0,0
	If dotcol=3 Then Color 255,255,0
	If dotcol=4 Then Color 0,0,255
	Oval mxx#-mag#*0.75,myy#-mag#*0.75,mag#*1.5,mag#*1.5

End Function


Function tomap(acar,bcar)

xdiff#=(EntityX(acar)-EntityX(bcar))*mapsize#/1280
ydiff#=(EntityZ(acar)-EntityZ(bcar))*mapsize#/1280
	
diffsize#=(xdiff#^2+ydiff#^2)^0.5
	
diffang#=calc_ang#(xdiff#,-ydiff#,mapangle#)
	
mapx#=mapcentx#+diffsize#*Sin(-diffang#)
mapy#=mapcenty#+diffsize#*Cos(-diffang#)

End Function


Function xydistance#(ent1,ent2)

xdist#=Abs(EntityX(ent1)-EntityX(ent2))
ydist#=Abs(EntityZ(ent1)-EntityZ(ent2))

distance#=(xdist#^2+ydist#^2)^0.5

Return(distance#)

End Function


Function cpustuff(gcar.vehic)

dfact#=1;+(ochoice(1)-1)*0.1


co_for=1
ccyaw#=EntityYaw(gcar\car)	
	
	findverts(gcar\onpiece,ccyaw#-90)
	peril#=vy1#-vy2#
	road_angle1#=road_angle#
	
	
	findverts(gcar\onpiece+5*(1-reverse*2),road_angle#+ccyaw#-90)
	road_angle2#=road_angle#

	
	findverts(gcar\onpiece)		
	findverts(gcar\onpiece+20*(1-reverse*2),road_angle#)
	roadf1#=road_angle#
	
	gcar\yup#=(vy#(1)+vy#(2))/2-EntityY(gcar\car)
	
		
	findverts(gcar\onpiece)		
	findverts(gcar\onpiece+40*(1-reverse*2),road_angle#)
	roadf2#=road_angle#
	
	findverts(gcar\onpiece)		
	findverts(gcar\onpiece+60*(1-reverse*2),road_angle#)
	roadf3#=road_angle#


	

	
	
	;cpu car turning into corners
	
	obturn#=gcar\spturn#
	dturn#=(d_ang#-(obturn#*0.2))
	
	dturn#=d_ang#
	dturn2#=-d_ang#*(gcar\speed)
	
	
	droad2#=Abs(roadf2#)*(gcar\speed)
	droad3#=Abs(roadf3#)*(gcar\speed)
	
	maxdrift#=-dturn2#*0.5
	If maxdrift#>30 Then maxdrift#=30
	If maxdrift#<-30 Then maxdrift#=-30
	
	If dturn2#>2 And road_angle1#>maxdrift# Then co_left=1
	If dturn2#<-2 And road_angle1#<maxdrift# Then co_right=1
	
	line_pos#=race_line#(gcar\onpiece)
	If reverse=1 Then line_pos#=1-line_pos#
	
	offline#=0.5+gcar\fromcent#/30-line_pos#
	
	uuu#=offline#+(gcar\spturn#)*0.5
		
	If uuu#>0.3 And road_angle1#>maxdrift# Then co_left=1
	If uuu#<-0.3 And road_angle1#<maxdrift# Then co_right=1
	
		
	If tunhere(gcar\onpiece)=0
	
	If gcar\fromcent#>12 And dturn2#>-10 And gcar\spturn#>-0.2 Then co_left=1:co_right=0
	If gcar\fromcent#<-12 And dturn2#<10 And gcar\spturn#<0.2 Then co_right=1:co_left=0
	
	
	If road_angle2#>10 And gcar\fromcent#>-12 Then co_right=0
	If road_angle2#<-10 And gcar\fromcent#<12 Then co_left=0
	
	If gcar\speed>0.7*dfact#
	;needed on reverse
	If road_angle2#<-45 Then co_right=1:co_for=0;co_rev=1
	If road_angle2#>45 Then co_left=1:co_for=0;co_rev=1
	EndIf
	
	EndIf
	
	If Abs(road_angle1#)*(gcar\speed)>30 Then co_for=0
		
		
	If Abs(dturn#)<=15 And Abs(roadf1#)<=15
	If Abs(gcar\spturn#)/Abs(road_angle2#+1)>0.2 And Abs(road_angle2#)<10	
	co_right=0:co_left=0			
	EndIf
	EndIf

			
	If Abs(dturn2#)>30 ;And Abs(roadf1#)>20
	co_for=0
	EndIf
	
	
	
	;cpu car slowing down for hairpin
	
	
	If droad2#>150 Or droad3#>150;Or (gcar\speed)*Abs(roadf2#)>150
	co_rev=1
	co_for=0
	EndIf
	
				
	;If watch=1 And numcars>10 And gcar\speed>0.6 Then co_for=0
		
	
	;slow if risk of crashing into another vehicle
	
	If numcars>1 ;And watch=0
	
	;carsense(gcar.vehic)	
	;If slowdown=1 Then co_for=0;co_rev=1
	
	EndIf
	
	If dvy#>5 Then co_for=1;co_rev=0
	
	If gcar\speed<0.7*dfact# Then co_for=1;co_rev=0
	
	mmm#=(road_angle1#+gcar\fromcent#)*(gcar\speed)
	
	
	
	If tunhere(gcar\onpiece)=0 And tunhere(get(gcar\onpiece,15))>0
	If Abs(roadf1#)>10 And Abs(dturn2#)>15
	
	co_for=0
	;If gcar\speed>0.7*dfact# Then co_rev=1
	If d_ang#>0 Then co_right=1:co_left=0
	If d_ang#<0 Then co_left=1:co_right=0
	
	EndIf
	EndIf
	
	
	
	
	If Abs(d_ang#)>45 And tunhere(gcar\onpiece)=0;And Abs(roadf1#)>20
	;needed on reverse
	co_for=0
	If d_ang#>0 Then co_right=1:co_left=0
	If d_ang#<0 Then co_left=1:co_right=0
	EndIf
	
	If tunhere(gcar\onpiece)>0 And tunhere(get(gcar\onpiece,15))>0
	If road_angle1#>5 Then co_right=0
	If road_angle1#<-5 Then co_left=0
	EndIf
	
	;if there is a big slope
	;If yup#>30		
	;EndIf
	
				
End Function


Function backtotitles()

ingame=0:offset#=603
twoset#=603:toggle=1
option=1:boxpoint=1
alpha#=0:waiting=MilliSecs()

HideEntity numsprite

HideEntity coursemap
RotateEntity coursemap,0,0,0

End Function



Function createmap(trnum,active=1)


sev=OpenFile("tracks/trackdata"+trnum+".dat")

If sev<>0
totverts=ReadInt(sev)

totvert(trnum)=totverts

If active=0
CloseFile sev
Return(1)
EndIf


For hm=0 To totverts-1
;If hm Mod 4=1 Then hm=hm+2

For hn=1 To 3
;If hn=2 Then hn=3
;SeekFile(sev,hm*12+hn*4)

tmapdata#(hm,hn)=ReadFloat(sev)

;If mirror=1 And hn=1 Then tmapdata#(hm,hn)=-tmapdata#(hm,hn)+m_offset#(tracknum)

Next
Next

FreeImage map


map=CreateImage(300,300)

SetBuffer ImageBuffer(map)

Color 255,255,255;10,10,10

Rect 0,0,300,300

vax#=0:vay#=0:vbx#=0:vby#=0

aleft=300
aright=0
atop=300
abottom=0

For ll=4 To totverts Step 4

If ll=12 Then Color 5,5,5

olx#=vax#
oly#=vay#
omx#=vbx#
omy#=vby#

vax#=150+tmapdata#(ll-4,1)/5
vay#=150-tmapdata#(ll-4,3)/5
vbx#=150+tmapdata#(ll-1,1)/5
vby#=150-tmapdata#(ll-1,3)/5

If vax#<aleft Then aleft=vax#
If vbx#<aleft Then aleft=vbx#
If vax#>aright Then aright=vax#
If vbx#>aright Then aright=vbx#

If vay#<atop Then atop=vay#
If vby#<atop Then atop=vby#
If vay#>abottom Then abottom=vay#
If vby#>abottom Then abottom=vby#

If ll=4
fx#=(vax#+vbx#)/2
fy#=(vay#+vby#)/2
EndIf


If ll>4

steps#=10

For qq#=1 To steps#
deci#=qq#/steps#
Line olx#*(1-deci#)+vax#*deci#,oly#*(1-deci#)+vay#*deci#,omx#*(1-deci#)+vbx#*deci#,omy#*(1-deci#)+vby#*deci#
Next

EndIf

Next

EndIf


mapart=CreateImage(aright-aleft,abottom-atop)
GrabImage mapart,aleft,atop

ok=SaveImage(mapart,"maps/map"+trnum+".bmp")

odxy#(trnum,1)=fx#-(aleft+aright)/2
odxy#(trnum,2)=fy#-(atop+abottom)/2

;SetBuffer BackBuffer()
;maskit(map,4)
;EntityTexture coursemap,map

End Function



Function new_scene()



ClearSurface psurf ;clear water plane

ClearSurface surface ;deletes road from previously loaded track

ClearSurface racelinesurf ;clears the racing line's surface

ClearSurface gridsurf

FreeTexture track
track=LoadTexture(get_road_texture$(tracknum))
EntityTexture road,track
EntityShininess road,1

FreeEntity terr ;deletes terrain from previously loaded track

For jc.scenery = Each scenery
FreeEntity jc\ent	;deletes scenery from old track (just trees so far)
Delete jc
Next

For jd.rtunnel = Each rtunnel
FreeEntity jd\ent
Delete jd
Next

ClearSurface w1surf ;remove all tris/verts from the left wall
ClearSurface w2surf	;remove all tris/verts from the right wall



terr=get_terrain(tracknum,mirror) ;new terrain

;mir_offset#=-1000+(TerrainSize(terr)-1)*scale#
;-1000 = double terrs left x posn

FreeTexture tex
tex=LoadTexture(get_terr_texture$(tracknum))
ScaleTexture tex,5,5

EntityTexture terr,tex
EntityType terr,SCENE


createroad("tracks/trackdata"+tracknum+".dat")

;new road (+ walls and scenery)

loadedtrack=tracknum ;the loaded track is now the current track
cmirror=mirror ;track mirror is now current mirror

makeplane(3000,40,watertex,waterlev#,1)


End Function


Function save()

tts=WriteFile("gamedata/records.dat")

WriteInt tts,racetracks

For kg=1 To racetracks

For kh=1 To 8
For ki=1 To 5

WriteString tts,recname$(kg,kh,ki)
WriteInt tts,records(kg,kh,ki)

Next
Next

Next


CloseFile tts



ggs=WriteFile("gamedata/ghostcars.dat")

WriteInt ggs,racetracks

For kg=1 To racetracks

For km=1 To 4
;normal/reverse/mirror

For cx=1 To 20
WriteInt ggs,gchecktime(kg,km,cx)
Next

WriteInt ggs,ghost_frames(kg,km)
WriteInt ggs,ghost_filesize(kg,km)

For kh=0 To ghost_filesize(kg,km)

For ki=1 To 6
WriteFloat ggs,ghost#(kg,km,kh,ki)
Next
Next


Next

Next

CloseFile ggs



hhs=WriteFile("gamedata/regnames.dat")

namecount=0
For kc.name = Each name
namecount=namecount+1
Next
WriteInt hhs,namecount


For kp.name = Each name
WriteString hhs,kp\player$
Next

CloseFile hhs


iis=WriteFile("gamedata/mapoffsets.dat")

For mm=1 To racetracks
WriteFloat iis,odxy#(mm,1)
WriteFloat iis,odxy#(mm,2)
Next

CloseFile iis


jjs=WriteFile("gamedata/options.dat")

WriteInt jjs,opsize

For nn=1 To opsize
WriteInt jjs,ochoice(nn)
Next

CloseFile jjs

End Function


Function load()

tts=ReadFile("gamedata/records.dat")

If tts<>0

racetracks=ReadInt(tts)

For kg=1 To racetracks

For kh=1 To 8
For ki=1 To 5

recname$(kg,kh,ki)=ReadString(tts)
records(kg,kh,ki)=ReadInt(tts)

Next
Next
Next


CloseFile tts
EndIf


ggs=ReadFile("gamedata/ghostcars.dat")

If ggs<>0

racetracks=ReadInt(ggs)

For kg=1 To racetracks

For km=1 To 4 ;normal/reverse/mirror

For cx=1 To 20
gchecktime(kg,km,cx)=ReadInt(ggs)
Next

ghost_frames(kg,km)=ReadInt(ggs)
ghost_filesize(kg,km)=ReadInt(ggs)


For kh=0 To ghost_filesize(kg,km)

For ki=1 To 6
ghost#(kg,km,kh,ki)=ReadFloat(ggs)

Next
Next
Next
Next

CloseFile ggs
EndIf


hhs=ReadFile("gamedata/regnames.dat")

If hhs<>0

namecount=ReadInt(hhs)

For kc=1 To namecount

jj.name = New name
jj\player$=ReadString(hhs)

Next

CloseFile hhs

EndIf

iis=ReadFile("gamedata/mapoffsets.dat")

If iis<>0

For kd=1 To racetracks

odxy#(kd,1)=ReadFloat(iis)
odxy#(kd,2)=ReadFloat(iis)

Next

CloseFile iis

EndIf

jjs=ReadFile("gamedata/options.dat")

If jjs<>0

opsize=ReadInt(jjs)

For nn=1 To opsize
ochoice(nn)=ReadInt(jjs)
Next

CloseFile jjs

EndIf

End Function


Function updatebest(newtime,laprace)
;laprace = 1 (single lap) or 2 (race)

filepart=laprace*4+mirror*2+reverse-3

If newtime<=records(tracknum,laprace,5)

For tt=5 To 1 Step -1

If tt<5 And newtime<=records(tracknum,filepart,tt)
recname$(tracknum,filepart,tt+1)=recname$(tracknum,filepart,tt)
records(tracknum,filepart,tt+1)=records(tracknum,filepart,tt)
EndIf

ent=0
If tt>1 And newtime<=records(tracknum,filepart,tt) And newtime>records(tracknum,filepart,tt-1) Then ent=1
If tt=1 And newtime<=records(tracknum,filepart,tt) Then ent=1

If ent=1
recname$(tracknum,filepart,tt)=yourname$
records(tracknum,filepart,tt)=newtime
EndIf

Next

EndIf

End Function


Function endnumber$(number)

units=number Mod 10
tens=((number Mod 100)-units)/10

nend$="th"
If tens<>1
If units=1 Then nend$="st"
If units=2 Then nend$="nd"
If units=3 Then nend$="rd"
EndIf

Return(nend$)

End Function


Function update_num()

FreeTexture numtexture

numtexture=LoadTexture("stuff/temp"+countnum+".bmp",4)
	
maskit(numtexture,3)

EntityTexture numsprite,numtexture
EntityOrder numsprite,-1
	
End Function


Function vect#(axis,want)

If axis=1 Then vo#(0)=vx#(0):vo#(1)=vx#(1):vo#(2)=vx#(2):vo#(3)=vx#(3)
If axis=2 Then vo#(0)=vy#(0):vo#(1)=vy#(1):vo#(2)=vy#(2):vo#(3)=vy#(3)
If axis=3 Then vo#(0)=vz#(0):vo#(1)=vz#(1):vo#(2)=vz#(2):vo#(3)=vz#(3)

centre#=(vo#(1)+vo#(2))/2
roadvec1#=(vo#(2)-vo#(1))/2
roadvec2#=(vo#(3)-vo#(0))/2

If want=1 Then ret#=centre#
If want=2 Then ret#=roadvec1#
If want=3 Then ret#=roadvec2#

Return(ret#)

End Function

Function dorotex(sfact#)

roady#=roady#+rdx#*sfact#
	If roady#=1 Then rdx#=-0.1
	If roady#=0 Then rdx#=0.1

If index=totverts-5
If roady#<0.5 Then roady#=roady#+0.5
If roady#>=0.5 Then roady#=roady#-0.5
EndIf

End Function


Function ghostcalc#(cc,ccmid#,part)

pre#=ghost(tracknum,mirror*2+reverse+1,cc,part)
nex#=ghost(tracknum,mirror*2+reverse+1,cc+1,part)

If part<=3 Then interp#=pre#+(nex#-pre#)*(ccmid#/ghostween)
If part>=4 Then interp#=pre#+sortangle#(nex#-pre#)*(ccmid#/ghostween)

Return(interp#)

End Function


Function usechars(word$,xs,ys,size)

xxs=xs

For pp=1 To Len(word$)

q$=Mid$(word$,pp,1)
r=Asc(q$)-64

If r>0 And r<27
If size=1 Then DrawImage charset2,xxs,ys,r-1
If size=2 Then DrawImage charset,xxs,ys,r-1
EndIf

length=15
If r=9 Then length=5
If r=23 Then length=20
xxs=xxs+length*size

Next

End Function


Function newsprite(name$,sx#,sy#)

naa=CreateSprite(camera)
SpriteViewMode naa,2
ScaleSprite naa,sx#,sy#
HideEntity naa
nat=LoadTexture("stuff/"+name$+".bmp",4)
maskit(nat,3)
EntityTexture naa,nat
FreeTexture nat
EntityOrder naa,-1

Return(naa)

End Function


Function point(cent#)

posx#=vx#(1)+(vx#(2)-vx#(1))*cent#
posy#=vy#(1)+(vy#(2)-vy#(1))*cent#
posz#=vz#(1)+(vz#(2)-vz#(1))*cent#

End Function


Function getverts(slab,ahead#)

newp=get(slab,Sgn(ahead#))

For axis=1 To 3
For sect=1 To 2
result#=go#(slab,axis,sect)*(1-Abs(ahead#))+go#(newp,axis,sect)*Abs(ahead#)
If axis=1 Then vx#(sect)=result#
If axis=2 Then vy#(sect)=result#
If axis=3 Then vz#(sect)=result#
Next
Next
	
End Function


Function go#(piece,axis,sect)
If axis=1 Then ret#=VertexX(surface,piece*4+sect)
If axis=2 Then ret#=VertexY(surface,piece*4+sect)
If axis=3 Then ret#=VertexZ(surface,piece*4+sect)
Return(ret#)
End Function


Function newverts(slab,rectype,cen#,gxs#,gys#,wid#)

For wx=-1 To 1 Step 2

ahead#=wx*gys#
If wx=-1 And rectype=3 Then ahead#=gys#-wid#*3

getverts(slab,ahead#) ;get ahead points
For yz=-1 To 1 Step 2
wide#=cen#+yz*gxs#
If rectype=1 And yz=1 Then wide#=cen#-gxs#+wid#
If rectype=2 And yz=-1 Then wide#=cen#+gxs#-wid#

If mirror=1 Then wide#=1-wide#

point(wide#)
AddVertex gridsurf,posx#,posy#+0.2,posz#
Next
Next

total=CountVertices(gridsurf)
trion=0
If mirror<>reverse Then trion=2
newtri(gridsurf,total,1,3,2,trion)
newtri(gridsurf,total,2,3,4,trion)


End Function